/* $Header: /home/yav/xpx/RCS/area.c,v 1.2 1996/04/28 03:19:46 yav Exp $
 * xpx area edit
 * written by yav (UHD98984@pcvan.or.jp)
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>

#include "headers.h"
#include "xpx.h"
#include "work.h"
#include "editdef.h"
#include "icondef.h"

#define PUBLIC_AREA_C
#include "extern.h"

char rcsid_area[] = "$Id: area.c,v 1.2 1996/04/28 03:19:46 yav Exp $";

/* edit.c */
extern MENU editmenu2[];
/* hold.c */
extern AREA hold;


#define AREA_COPY	0
#define AREA_PASTE	1
#define AREA_FLIPV	2
#define AREA_SHIFTU	3
#define AREA_FLIPH	4
#define AREA_SHIFTL	5
#define AREA_FACTOR	6
#define AREA_SHIFTR	7
#define AREA_TURNL	8
#define AREA_SHIFTD	9
#define AREA_TURNR	10
#define AREA_OK	11

#define AREAWIDTH	108
#define AREAHEIGHT	216

#define MW 32
#define MH 32

int areaev();

#define IMASK (ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask)
static MENU areamenu[] = {
  {
    AREA_COPY, MenuModeMaskBorder,
    4, 4, 98, MH,
    0, IMASK, 0,
    areaev, NULL, 0, 0, "-> hold"
  },{
    AREA_PASTE, MenuModeMaskBorder,
    4, 4 + MH+BDW, 98, MH,
    0, IMASK, 0,
    areaev, NULL, 0, 0, "<- hold"
  },{
    AREA_FLIPV, MenuModeMaskBorder,
    4, 4 + MH+BDW + 4 + MH+BDW, MW, MH,
    0, IMASK, 0,
    areaev, NULL, 0, 0, NULL
  },{
    AREA_SHIFTU, MenuModeMaskBorder,
    4 + MW+BDW, 4 + MH+BDW + 4 + + MH+BDW, MW, MH,
    0, IMASK, 0,
    areaev, NULL, 0, 0, NULL
  },{
    AREA_FLIPH, MenuModeMaskBorder,
    4 + MW+BDW + MW+BDW, 4 + MH+BDW + 4+ + MH+BDW, MW, MH,
    0, IMASK, 0,
    areaev, NULL, 0, 0, NULL
  },{
    AREA_SHIFTL, MenuModeMaskBorder,
    4, 4 + MH+BDW + 4 + MH+BDW + MH+BDW, MW, MH,
    0, IMASK, 0,
    areaev, NULL, 0, 0, NULL
  },{
    AREA_FACTOR, MenuModeMaskBorder,
    4 + MW+BDW, 4 + MH+BDW + 4 + MH+BDW + MH+BDW, MW, MH,
    0, IMASK|KeyPressMask, 0,
    areaev, NULL, 0, 8, NULL
  },{
    AREA_SHIFTR, MenuModeMaskBorder,
    4 + MW+BDW + MW+BDW, 4 + MH+BDW + 4 + MH+BDW + MH+BDW, MW, MH,
    0, IMASK, 0,
    areaev, NULL, 0, 0, NULL
  },{
    AREA_TURNL, MenuModeMaskBorder,
    4, 4 + MH+BDW + 4 + MH+BDW + MH+BDW + MH+BDW, MW, MH,
    0, IMASK, 0,
    areaev, NULL, 0, 0, NULL
  },{
    AREA_SHIFTD, MenuModeMaskBorder,
    4 + MW+BDW, 4 + MH+BDW + 4 + MH+BDW + MH+BDW + MH+BDW, MW, MH,
    0, IMASK, 0,
    areaev, NULL, 0, 0, NULL
  },{
    AREA_TURNR, MenuModeMaskBorder,
    4 + MW+BDW + MW+BDW, 4 + MH+BDW + 4 + MH+BDW + MH+BDW + MH+BDW, MW, MH,
    0, IMASK, 0,
    areaev, NULL, 0, 0, NULL
  },{
    AREA_OK, MenuModeMaskBorder,
    4, 4, 64, 24,
    0, IMASK, SouthEastGravity,
    areaev, NULL, 0, 0, "OK"
  },{
    -1, 0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL
  }
};

static Window areawin;
static int shiftn = 1;		/* shift factor (pixel) */

int create_area_menu()
{
  create_toplevel_window(&areawin, "area", "",
			 AREAWIDTH, AREAHEIGHT);
  XSelectInput(dsp, areawin, ExposureMask);
  menuwin_create(areamenu, areawin, 0, 0);
  return 0;
}

void unmap_area_window()
{
  /* area menu open menu off */
  XUnmapWindow(dsp, areawin);
}

void map_area_window()
{
  XMapRaised(dsp, areawin);
}

/* get image processing area
 * return != 0: cannot to adjust
 */
int get_area(AREA *p)
{
  memcpy(p, &area0, sizeof(AREA));
  little_big(&p->x, &p->w);
  p->w -= p->x;
  little_big(&p->y, &p->h);
  p->h -= p->y;
  if (p->x < 0 || p->x >= imgfilew || p->w <= 0 ||
      p->y < 0 || p->y >= imgfileh || p->h <= 0) {
    p->x = p->y = 0;
    p->w = imgfilew;
    p->h = imgfileh;
  }
  if (p->x + p->w > imgfilew)
    p->w = imgfilew - p->x;
  if (p->y + p->h > imgfileh)
    p->h = imgfileh - p->y;
  return (p->w <= 0 || p->h <= 0);
}

int edit_paste_hold()
{
  int r;
  AREA ar;

  if (get_area(&ar))
    return 1;
  if (ar.w > hold.w)
    ar.w = hold.w;
  if (ar.h > hold.h)
    ar.h = hold.h;
  undo_push_area(ar.x, ar.y, ar.w, ar.h);
  r = load_holdspace(&ar);
  area_update(ar.x, ar.y, ar.w, ar.h);
  return r;
}

int edit_copy_hold()
{
  AREA ar;

  if (get_area(&ar))
    return 1;
  return save_holdspace(&ar);
}

/* vertical flip */
void flipv()
{
  int c, x, y;
  AREA ar;
  unsigned char *pt, *pb;
  
  if (get_area(&ar))
    return;
  undo_push_area(ar.x, ar.y, ar.w, ar.h);
  for (y = 0; y < ar.h/2; y++) {
    pt = imgdata + imgmaxw * (ar.y + y) + ar.x;
    pb = imgdata + imgmaxw * (ar.y + ar.h - 1 - y) + ar.x;
    for (x = ar.w; x; --x) {
      c = *pt;
      *pt++ = *pb;
      *pb++ = c;
    }
  }
  update_area(ar.x, ar.y, ar.w, ar.h); /* update XImage */
  area_update(ar.x, ar.y, ar.w, ar.h);
}

/* horizontal flip */
void fliph()
{
  int c, x, y;
  AREA ar;
  unsigned char *pl, *pr;
  
  if (get_area(&ar))
    return;
  undo_push_area(ar.x, ar.y, ar.w, ar.h);
  for (y = ar.y; y < ar.y + ar.h; y++) {
    pl = imgdata + imgmaxw * y + ar.x;
    pr = pl + ar.w;
    for (x = ar.w/2; x; --x) {
      c = *(--pr);
      *pr = *pl;
      *pl++ = c;
    }
  }
  update_area(ar.x, ar.y, ar.w, ar.h); /* update XImage */
  area_update(ar.x, ar.y, ar.w, ar.h);
}

/* horizontal shift */
void hshift(sh)
     int sh;			/* shift pixels (minus:left, plus:right) */
{
  int y;
  AREA ar;
  unsigned char *p;
  unsigned char *lnbuf;
  int storefrom, storeto, storelen, movefrom, moveto;
  
  if (get_area(&ar))
    return;
  undo_push_area(ar.x, ar.y, ar.w, ar.h);
  sh %= ar.w;
  if (sh < 0) {
    /* shift left */
    sh = -sh;
    storefrom = sh; storeto = 0;
    movefrom = 0; moveto = ar.w - sh;
  } else {
    /* shift right */
    storefrom = 0; storeto = sh;
    movefrom = ar.w - sh; moveto = 0;
  }
  storelen = ar.w - sh;
  lnbuf = malloc(storelen);
  for (y = ar.y; y < ar.y + ar.h; y++) {
    p = imgdata + imgmaxw * y + ar.x;
    memcpy(lnbuf, p + storefrom, storelen);
    memcpy(p + moveto, p + movefrom, sh); /* Not overlap */
    memcpy(p + storeto, lnbuf, storelen);
  }
  free(lnbuf);
  update_area(ar.x, ar.y, ar.w, ar.h); /* update XImage */
  area_update(ar.x, ar.y, ar.w, ar.h);
}

/* vertical shift */
void vshift(sh)
     int sh;			/* shift pixels (minus:up, plus:down) */
{
  int x, y;
  AREA ar;
  unsigned char *p;
  unsigned char *lnbuf;
  
  if (get_area(&ar))
    return;
  undo_push_area(ar.x, ar.y, ar.w, ar.h);
  sh %= ar.h;
  if (sh < 0) {
    /* shift up */
    sh = -sh;
    lnbuf = malloc(sh);
    for (x = ar.x; x < ar.x + ar.w; x++) {
      p = imgdata + imgmaxw * ar.y + x;
      for (y = 0; y < sh; y++)
	*(lnbuf + y) = *(p + imgmaxw * y);
      for (y = 0; y < ar.h - sh; y++)
	*(p + imgmaxw * y) = *(p + imgmaxw * (sh + y));
      for (y = 0; y < sh; y++)
	*(p + imgmaxw * (ar.h - sh + y)) = *(lnbuf + y);
    }
  } else {
    /* shift down */
    lnbuf = malloc(sh);
    for (x = ar.x; x < ar.x + ar.w; x++) {
      p = imgdata + imgmaxw * ar.y + x;
      for (y = 0; y < sh; y++)
	*(lnbuf + y) = *(p + imgmaxw * (ar.h - sh + y));
      for (y = ar.h - sh - 1; y >= 0; --y)
	*(p + imgmaxw * (sh + y)) = *(p + imgmaxw * y);
      for (y = 0; y < sh; y++)
	*(p + imgmaxw * y) = *(lnbuf + y);
    }
  }
  free(lnbuf);
  update_area(ar.x, ar.y, ar.w, ar.h); /* update XImage */
  area_update(ar.x, ar.y, ar.w, ar.h);
}

void turn90r(n)
     int n;
{
  int i, c, x, y, w;
  AREA ar;
  
  if (get_area(&ar))
    return;
  undo_push_area(ar.x, ar.y, ar.w, ar.h);
  while (n--) {
    w = ar.w < ar.h ? ar.w : ar.h;
    for (x = ar.x, y = ar.y; w > 0; x++, y++, w -= 2) {
      for (i = 0; i < w-1; i++) {
	c = *(imgdata+imgmaxw*y+x+i);
	*(imgdata+imgmaxw*y+x+i) = *(imgdata+imgmaxw*(y+w-1-i)+x);
	*(imgdata+imgmaxw*(y+w-1-i)+x) = *(imgdata+imgmaxw*(y+w-1)+x+w-1-i);
	*(imgdata+imgmaxw*(y+w-1)+x+w-1-i) = *(imgdata+imgmaxw*(y+i)+x+w-1);
	*(imgdata+imgmaxw*(y+i)+x+w-1) = c;
      }
    }
  }
  update_area(ar.x, ar.y, ar.w, ar.h); /* update XImage */
  area_update(ar.x, ar.y, ar.w, ar.h);
}


int areaev(p, ev)
     MENU *p;
     XEvent *ev;
{
  int i;
  KeySym key;
  char buf[16];
  
  switch(ev->type) {
  case Expose:
    if (ev->xexpose.count)
      break;
    switch (p->n) {
    case AREA_FLIPV:
      i = ICON_flipv;
      break;
    case AREA_SHIFTU:
      i = ICON_up;
      break;
    case AREA_FLIPH:
      i = ICON_fliph;
      break;
    case AREA_SHIFTL:
      i = ICON_left;
      break;
    case AREA_SHIFTR:
      i = ICON_right;
      break;
    case AREA_TURNL:
      i = ICON_turnl;
      break;
    case AREA_SHIFTD:
      i = ICON_down;
      break;
    case AREA_TURNR:
      i = ICON_turnr;
      break;
    default:
      return 0;
    }
    menu_icon_center(p, i);
    return 1;
  case ButtonPress:
    switch (p->n) {
    case AREA_OK:
      unmap_area_window();
      editmenu2[EDIT2_AREA].mode &= ~MenuModeMaskOn;
      redraw_window(editmenu2[EDIT2_AREA].win);
      break;
    case AREA_COPY:
      edit_copy_hold();
      break;
    case AREA_PASTE:
      edit_paste_hold();
      break;
    case AREA_FLIPV:
      flipv();
      break;
    case AREA_FLIPH:
      fliph();
      break;
    case AREA_SHIFTL:
      hshift(-shiftn);
      break;
    case AREA_SHIFTR:
      hshift(shiftn);
      break;
    case AREA_SHIFTU:
      vshift(-shiftn);
      break;
    case AREA_SHIFTD:
      vshift(shiftn);
      break;
    case AREA_TURNL:
      turn90r(3);
      break;
    case AREA_TURNR:
      turn90r(1);
      break;
    }
    p->mode &= ~MenuModeMaskOn;
    redraw_window(p->win);
    return 1;
  case KeyPress:
    i = XLookupString((XKeyEvent *)ev, buf, sizeof(buf)-1, &key, NULL);
    buf[i] = '\0';
    switch(key) {
    case XK_KP_Enter:
    case XK_Return:
      shiftn = strtol(p->str, NULL, 0);
      sprintf(p->str, "%d", shiftn);
      redraw_window(p->win);
      return 1;
    }
    break;
  }
  return 0;
}

/* End of file */
