/* $Header: /home/yav/xpx/RCS/cbb.c,v 1.8 1995/11/23 16:28:39 yav Exp $
 * xpx save load PC-Engine .cbb .ccb format
 * written by yav (UHD98984@pcvan.or.jp)
 */

#include <X11/Xlib.h>

#include "headers.h"
#include "xpx.h"
#include "work.h"
#include "extern.h"

char rcsid_cbb[] = "$Id: cbb.c,v 1.8 1995/11/23 16:28:39 yav Exp $";

static unsigned char lbittbl[8] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};

int set_ccb_sub()
{
  free_color();
  get_color(color_buf+current_pal*MAXCOLSET, MAXCOLSET);
  image_update_col();
  return 0;
}

int read_ccb_sub(fp, func)
     FILE *fp;
     void (*func)();
{
  unsigned char buf[2*MAXCOLSET];
  int i, r;
  COL *p;
  
  p = color_buf;
  r = 0;
  while (fread(buf, 2*MAXCOLSET, 1, fp) != 0) {
    for (i = 0; i < MAXCOLSET; i++) {
      func(p, buf+i*2);
      p++;
    }
    r++;
  }
  if (r != MAXPALSET)
    return 1;
  return set_ccb_sub();
}

static unsigned char dfcoltbl[8] = {
  0, 70, 120, 160, 180, 200, 230, 255
  };

void conv_ccb(p, buf)
     COL *p;
     unsigned char *buf;
{
  p->rgb.blue = *buf & 7;
  p->rgb.red = (*buf>>3) & 7;
  p->rgb.green = ((*buf>>6) & 3)|((*(buf+1)&1) << 2);
  p->rgb.blue = dfcoltbl[p->rgb.blue];
  p->rgb.red = dfcoltbl[p->rgb.red];
  p->rgb.green = dfcoltbl[p->rgb.green];
}

/* read CE.EXE ccb */
int rd_ccb(fp)
     FILE *fp;
{
  return read_ccb_sub(fp, conv_ccb);
}

#define cv5to8(x) (((x)<<3)|((x)>>2))
void conv_cxb(p, buf)
     COL *p;
     unsigned char *buf;
{
  register int i;
  
  i = *buf & 31;
  p->rgb.red = cv5to8(i);
  i = (*buf>>5) | ((*(buf+1)&3)<<3);
  p->rgb.green = cv5to8(i);
  i = (*(buf+1))>>2;
  p->rgb.blue = cv5to8(i);
}

int rd_cxb(fp)
     FILE *fp;
{
  return read_ccb_sub(fp, conv_cxb);
}


int write_ccb_sub(
#if NeedFunctionPrototypes
		 FILE *fp, void (*func)())
#else
     fp, func)
     FILE *fp;
     void (*func)();
#endif
{
  unsigned char buf[2*MAXCOLSET];
  int i, set;
  COL *p;
  
  p = color_buf;
  for (set = 0; set < MAXPALSET; set++) {
    for (i = 0; i < MAXCOLSET; i++) {
      func(p, buf+i*2);
      p++;
    }
    if (!fwrite(buf, 2*MAXCOLSET, 1, fp))
      break;
  }
  if (set != MAXPALSET)
    return 1;
  return set_ccb_sub();
}


int cv8to3(n)
     int n;
{
  int i;
  
  for (i = 0; i < 7; i++)
    if (n < (dfcoltbl[i] + dfcoltbl[i+1])/2)
      break;
  return i;
}

void to_ccb(
#if NeedFunctionPrototypes
	      COL *p, unsigned char *buf)
#else
     p, buf)
     COL *p;
     unsigned char *buf;
#endif
{
  int r, g, b;
  
  r = cv8to3(p->rgb.red);
  g = cv8to3(p->rgb.green);
  b = cv8to3(p->rgb.blue);
  *buf = (g << 6) | (r << 3) | b;
  *(buf+1) = (g >> 2);
}

int wr_ccb(
#if NeedFunctionPrototypes
       FILE *fp)
#else
     fp)
     FILE *fp;
#endif
{
  return write_ccb_sub(fp, to_ccb);
}

void to_cxb(
#if NeedFunctionPrototypes
       COL *p, unsigned char *buf)
#else
     p, buf)
     COL *p;
     unsigned char *buf;
#endif
{
  int r, g, b;
  
  r = p->rgb.red >> 3;
  g = p->rgb.green >> 3;
  b = p->rgb.blue >> 3;
  *buf = (g << 5)|r;
  *(buf+1) = (b << 2)|(g >> 3);
}

int wr_cxb(
#if NeedFunctionPrototypes
       FILE *fp)
#else
     fp)
     FILE *fp;
#endif
{
  return write_ccb_sub(fp, to_cxb);
}


#define BITCHKCBB(p0,c0,b) \
{pp = p0+7; c = c0; while (c) {if (c & 1) *pp |= b; --pp; c >>= 1;}}

void conv_cbbfont(p, cbb)
     unsigned char *p;
     unsigned char *cbb;
{
  unsigned char c;
  unsigned char *pp;
  int y;
  
  bzero(p, 8*8);
  y = 8;
  while (y--) {
    BITCHKCBB(p,*cbb,1);
    BITCHKCBB(p,*(cbb+1),2);
    BITCHKCBB(p,*(cbb+16),4);
    BITCHKCBB(p,*(cbb+17),8);
    p += 8;
    cbb += 2;
  }
}
#undef BITCHKCBB

#define IMGCOPY8(dst,src) (memcpy(dst,src,8), src+=8, dst+=imgmaxw)
void set_font8x8(p, x0, y0)
     unsigned char *p;
     int x0;
     int y0;
{
  unsigned char *dst;

  dst = imgdata+y0*imgmaxw+x0;
  IMGCOPY8(dst,p);
  IMGCOPY8(dst,p);
  IMGCOPY8(dst,p);
  IMGCOPY8(dst,p);
  IMGCOPY8(dst,p);
  IMGCOPY8(dst,p);
  IMGCOPY8(dst,p);
  IMGCOPY8(dst,p);
}
#undef IMGCOPY8

void gen_image_cbb(cbb)
     unsigned char *cbb;
{
  int x, y;
  unsigned char fontpix[8*8];
  
  for (y = 0; y < 16; y++) {
    for (x = 0; x < 16; x++) {
      conv_cbbfont(fontpix, cbb);
      set_font8x8(fontpix, x<<3, y<<3);
      cbb += 32;
    }
  }
}

/* read CE.EXE cbb */
int rd_cbb(fp)
     FILE *fp;
{
  int r;
  unsigned char cbb_data[32*256];
  
  init_image();
  r = fread(cbb_data, sizeof(cbb_data), 1, fp);
  if (!r)
    return 1;
  gen_image_cbb(cbb_data);
  imgupdate(128, 128);
  return 0;
}

void conv_csbfont(p, csb)
     unsigned char *p;
     unsigned char *csb;
{
  int x, y;
  
  for (y = 0; y < 8; y++) {
    for (x = 0; x < 8; x++) {
      if (*csb & lbittbl[x])
	*p = 1;
      else
	*p = 0;
      if (*(csb+0x20) & lbittbl[x])
	*p |= 2;
      if (*(csb+0x40) & lbittbl[x])
	*p |= 4;
      if (*(csb+0x60) & lbittbl[x])
	*p |= 8;
      p++;
    }
    csb += 2;
  }
}

void csb_font1(csb, x, y)
     unsigned char *csb;
     int x;
     int y;
{
  unsigned char fontpix[8*8];
  
  conv_csbfont(fontpix, csb+1);
  set_font8x8(fontpix, x, y);
  conv_csbfont(fontpix, csb);
  set_font8x8(fontpix, x+8, y);
  conv_csbfont(fontpix, csb+16+1);
  set_font8x8(fontpix, x, y+8);
  conv_csbfont(fontpix, csb+16);
  set_font8x8(fontpix, x+8, y+8);
}

void gen_image_csb(csb)
     unsigned char *csb;
{
  int x, y;
  
  for (x = 0; x < 4; x++) {
    for (y = 0; y < 8; y++) {
      csb_font1(csb, x*32, y*16);
      csb += 128;
      csb_font1(csb, x*32+16, y*16);
      csb += 128;
    }
  }
}

/* read CE.EXE csb */
int rd_csb(fp)
     FILE *fp;
{
  int r;
  unsigned char csb_data[32*256];
  
  init_image();
  r = fread(csb_data, sizeof(csb_data), 1, fp);
  if (!r)
    return 1;
  gen_image_csb(csb_data);
  imgupdate(128, 128);
  return 0;
}


void gen_cbbfont(
#if NeedFunctionPrototypes
		 unsigned char *dst, unsigned char *src)
#else
     dst, src)
     unsigned char *dst;
     unsigned char *src;
#endif
{
  int x, y;
  static unsigned char bittbl[8] =
    {0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01};
  
  bzero(dst, 32);
  for (y = 0; y < 8; y++) {
    for (x = 0; x < 8; x++) {
      if (*src & 1)
	*dst |= bittbl[x];
      if (*src & 2)
	*(dst+1) |= bittbl[x];
      if (*src & 4)
	*(dst+16) |= bittbl[x];
      if (*src & 8)
	*(dst+17) |= bittbl[x];
      src++;
    }
    src += imgmaxw-8;
    dst += 2;
  }
}

/* write CE.EXE cbb */
int wr_cbb(
#if NeedFunctionPrototypes
       FILE *fp)
#else
     fp)
     FILE *fp;
#endif
{
  int x, y;
  unsigned char *p;
  unsigned char cbbfont[32];
  
  for (y = 0; y < 16; y++) {
    p = imgdata + y*8*imgmaxw;
    for (x = 0; x < 16; x++) {
      gen_cbbfont(cbbfont, p);
      if (!fwrite(cbbfont, sizeof(cbbfont), 1, fp))
	return 1;
      p += 8;
    }
  }
  return 0;
}

/* End of file */
