/* $Header: /home/yav/xpx/RCS/colset.c,v 1.35 1996/04/26 17:22:47 yav Exp $
 * color edit
 * written by yav (UHD98984@pcvan.or.jp)
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>

#include "headers.h"
#include "xpx.h"
#include "work.h"
#include "cursdef.h"
#define PUBLIC_COLSET_C
#include "extern.h"


#define COLSETW 64
#define COLSETH 18
#define COLBOXH (COLSETH-2)	/* < COLSETH */
#define COLBOXW COLBOXH		/* < COLSETW */

#define COLEDX	400
#define COLEDY	50
#define COLEDDX	20
#define COLEDDY	32

#define COLBARH	16
#define COLEDW	380
#define COLEDH	(COLBARH*3+BDW*2)
#define COLED_COLOR	0
#define COLED_NRED	1
#define COLED_NGREEN	2
#define COLED_NBLUE	3
#define COLED_RED	4
#define COLED_GREEN	5
#define COLED_BLUE	6
#define COLED_OK	7

#define coled_num(p)	(get_top_menu(p)->cursor)
#define coled_colnum(p)	(current_pal*MAXCOLSET+coled_num(p))
#define coled_col(p)	(color_buf+coled_colnum(p))

char rcsid_colset[] = "$Id: colset.c,v 1.35 1996/04/26 17:22:47 yav Exp $";

static Bool coledopened[MAXCOLSET];
static Window coledwin[MAXCOLSET];
static MENU *coledmn[MAXCOLSET];
static unsigned long rgb_pixel[3];
static GC gc_rgb[3];
static Window colorbarwin[MAXCOLSET][3];
static char color_digit_initstr[] = "?";

int coledev();
int colednev();
char *coledstr();

#define IMASK	\
(ExposureMask|ButtonPressMask|EnterWindowMask|LeaveWindowMask|ButtonMotionMask)
static MENU coledmenu[] = {
  {
    COLED_COLOR,	MenuModeMaskBorder,
    2, 2, 32, COLEDH-BDW*2-4,
    0, ExposureMask|ButtonPressMask|EnterWindowMask|LeaveWindowMask, 0,
    coledev, NULL, 0, 0, ""},
  {
    COLED_NRED,	MenuModeMaskBorder,
    48, 0, 32, COLBARH-BDW,
    0, ExposureMask|KeyPressMask|EnterWindowMask|LeaveWindowMask, 0,
    colednev, coledstr, 0, 8, NULL},
  {
    COLED_NGREEN,	MenuModeMaskBorder,
    48, COLBARH, 32, COLBARH-BDW,
    0, ExposureMask|KeyPressMask|EnterWindowMask|LeaveWindowMask, 0,
    colednev, coledstr, 0, 8, NULL},
  {
    COLED_NBLUE,	MenuModeMaskBorder,
    48, COLBARH*2, 32, COLBARH-BDW,
    0, ExposureMask|KeyPressMask|EnterWindowMask|LeaveWindowMask, 0,
    colednev, coledstr, 0, 8, NULL},
  {
    COLED_RED,	MenuModeMaskBorder,
    48+32, 0, 256+2, COLBARH-BDW,
    0, IMASK, 0,
    coledev, NULL, 0, 0, ""},
  {
    COLED_GREEN,	MenuModeMaskBorder,
    48+32, COLBARH, 256+2, COLBARH-BDW,
    0, IMASK, 0,
    coledev, NULL, 0, 0, ""},
  {
    COLED_BLUE,	MenuModeMaskBorder,
    48+32, COLBARH*2, 256+2, COLBARH-BDW,
    0, IMASK, 0,
    coledev, NULL, 0, 0, ""},
  {
    COLED_OK,	MenuModeMaskBorder,
    BDW*2+2, BDW*2+2, 32, 20,
    0, ExposureMask|ButtonPressMask|EnterWindowMask|LeaveWindowMask,
    SouthEastGravity,
    coledev, NULL, 0, 0, "OK"},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}
};

char *redraw_col(p)
     MENU *p;
{
  int len, w, ww;
  GC g;
  COL *cp;
  char buf[256];
  
  cp = color_buf+current_pal*MAXCOLSET+p->n;
  if (!(coltbl[p->n] & CM_ALLOCED))
    return "None";
  sprintf(buf, "%x%c%x%x%x", p->n, (coltbl[p->n]&CM_PRIVATE?':':'.'),
	  cp->rgb.green>>4, cp->rgb.red>>4, cp->rgb.blue>>4);
  len = strlen(buf);
  ww = COLSETW-COLBOXW;
  XFillRectangle(dsp, p->win, colgc[p->n], 1, 1, COLBOXW, COLBOXH);
  if (*(colmask+current_pal*MAXCOLSET+p->n)) {
    XDrawLine(dsp, p->win, gc1, 1, 1, COLBOXW-1, COLBOXH-1);
    XDrawLine(dsp, p->win, gc0, COLBOXW-1, 1, 1, COLBOXH-1);
  }
  if (p->mode & MenuModeMaskOn) {
    XFillRectangle(dsp, p->win, gc0, COLBOXW, 1, ww, COLBOXH);
    g = gc1;
  } else {
    g = gc0;
  }
  w = XTextWidth(fs0, buf, len);
  XDrawImageString(dsp, p->win, g, COLBOXW+(ww-w)/2, COLSETH-5, buf, len);
  menu_highlight(p);
  return NULL;
}

void set_current_color(n)
     int n;
{
  int oldcol;
  
  if (n != current_col) {
    oldcol = current_col;
    current_col = n;
    if (oldcol >= 0 && oldcol < MAXCOLSET) {
      colmenu[oldcol].mode &= ~MenuModeMaskOn;
      redraw_window(colmenu[oldcol].win);
    }
    if (n >= 0 && n < MAXCOLSET) {
      colmenu[n].mode |= MenuModeMaskOn;
      redraw_window(colmenu[n].win);
    }
    redraw_window(cursmenu[CURS_CURC].win);
  }
}

void unmap_coled_window(n)
     int n;
{
  XUnmapWindow(dsp, coledwin[n]);
  coledopened[n] = False;
}

void clear_color_digits(p)
     MENU *p;
{
  strcpy((p+COLED_NRED)->str, color_digit_initstr);
  strcpy((p+COLED_NGREEN)->str, color_digit_initstr);
  strcpy((p+COLED_NBLUE)->str, color_digit_initstr);
}

int create_coledit_window(n)
     int n;
{
  MENU *p;
  int i;
  char name[256];
  char buf[256];
  
  if (n >= MAXCOLSET) {
    error("coledit: color %d!", n);
    return 1;
  }
  if (coledwin[n]) {
    XMapWindow(dsp, coledwin[n]);
    coledopened[n] = True;
    return 0;
  }
  sprintf(name, "%s color %d", myname, n);
  sprintf(buf, "%dx%d+%d+%d",
	  COLEDW, COLEDH, COLEDX+COLEDDX*n, COLEDY+COLEDDY*n);
  create_toplevel_window(&coledwin[n], name, buf, COLEDW, COLEDH);
  XSelectInput(dsp, coledwin[n], ExposureMask);
  XMapRaised(dsp, coledwin[n]);
  p = (MENU *)malloc(sizeof(coledmenu));
  if (p == NULL) {
    error("more core!");
    return 1;
  }
  memcpy(p, coledmenu, sizeof(coledmenu));
  p->cursor = n;		/* color edit window number */
  menuwin_create(p, coledwin[n], 0, 0);
  clear_color_digits(p);
  coledmn[n] = p;
  for (i = 0; i < 3; i++) {
    static int ntbl[3] = {COLED_RED, COLED_GREEN, COLED_BLUE};
    colorbarwin[n][i] = XCreateSimpleWindow(dsp, (p+ntbl[i])->win,
					    BDW, BDW, 100, COLBARH-BDW*3,
					    0, fg, rgb_pixel[i]);
    XSelectInput(dsp, colorbarwin[n][i], ExposureMask|EnterWindowMask|LeaveWindowMask);
    XMapWindow(dsp, colorbarwin[n][i]);
  }
  coledopened[n] = True;
  return 0;
}

/* alternate color mask on/off */
void color_mask_alt(n)
     int n;
{
  *(colmask+current_pal*MAXCOLSET+n) ^= 1;
  redraw_window(colmenu[n].win);
}

void color_mask_alt_all()
{
  int i;
  
  for (i = 0; i < MAXCOLSET; i++)
    color_mask_alt(i);
}


int colev(p, ev)
     MENU *p;
     XEvent *ev;
{
  static int copy_src = -1;
  
  switch(ev->type) {
  case ButtonPress:
    switch(ev->xbutton.button) {
    case Button1:
      copy_src = p->n;
      if (double_clicked) {
	if (coledopened[p->n])
	  unmap_coled_window(p->n);
	else
	  create_coledit_window(p->n);
      } else {
	set_current_color(p->n);
      }
      return 1;
    case Button2:
    case Button3:
      /* mask on/off */
      color_mask_alt(p->n);
      return 1;
    }
    break;
  case ButtonRelease:
    if (copy_src >= 0 && copy_src != p->n) {
      if (debug_mode)
	fprintf(stderr, "colev: copy color %d -> %d\n", copy_src, p->n);
      undo_push_color(current_pal*MAXCOLSET+p->n, 1);
      memcpy(
	     color_buf+current_pal*MAXCOLSET+p->n,
	     color_buf+current_pal*MAXCOLSET+copy_src,
	     sizeof(COL));
      colchanged = 1;
      change_color(current_pal*MAXCOLSET+p->n);
    }
    copy_src = -1;
    return 1;
  case LeaveNotify:
    break;
  }
  return 0;
}

void get_rgb_gc()
{
  int i;
  XColor col;
  static char *name[3] = {"red", "green", "blue"};
  
  for (i = 0; i < 3; i++) {
    gc_rgb[i] = XCreateGC(dsp, win, 0, 0);
    XSetBackground(dsp, gc_rgb[i], bg);
    XSetForeground(dsp, gc_rgb[i], fg);
    if (parse_color(&col, name[i]) == 0) {
      rgb_pixel[i] = col.pixel;
      XSetForeground(dsp, gc_rgb[i], col.pixel);
    }
  }
}

int create_colset_window(win, x, y)
     Window win;
     int x;
     int y;
{
  int i;
  MENU *p;
  
  p = colmenu;
  for (i = 0; i < MAXCOLSET; i++) {
    bzero(p, sizeof(*p));
    p->n = i;
    p->y = (COLSETH+BDW)*i;
    p->w = COLSETW;
    p->h = COLSETH;
    p->im = ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask|ButtonReleaseMask|OwnerGrabButtonMask;
    p->mode = MenuModeMaskBorder;
    p->event = colev;
    p->strfunc = redraw_col;
    p++;
  }
  p->n = -1;
  topmenuwin_create(colmenu, x, y);
  for (i = 0; i < MAXCOLSET; i++)
    colgc[i] = XCreateGC(dsp, colmenu[i].win, 0, 0);
  bzero(coledmn, sizeof(coledmn));
  bzero(coledopened, sizeof(coledopened));
  get_rgb_gc();
  return 0;
}

void update_coled_sub(n)
     int n;
{
  MENU *p;
  
  if (coledwin[n]) {
    redraw_window(coledwin[n]);
    p = coledmn[n];
    clear_color_digits(p);
    while (p->n >= 0) {
      redraw_window(p->win);
      p++;
    }
  }
}

void update_coled_window()
{
  int i;
  
  for (i = 0; i < MAXCOLSET; i++)
    update_coled_sub(i);
}

void update_colmenu(n)
     int n;
{
  update_coled_sub(n);
  redraw_window(colmenu[n].win);
}


char *coledstr(p)
     MENU *p;
{
  int i;
  
  switch(p->n) {
  case COLED_NRED:
    i = coled_col(p)->rgb.red;
    break;
  case COLED_NGREEN:
    i = coled_col(p)->rgb.green;
    break;
  case COLED_NBLUE:
    i = coled_col(p)->rgb.blue;
    break;
  }
  if (strcmp(p->str, color_digit_initstr) == 0)
    sprintf(p->str, "%d", i);
  return p->str;
}

void draw_rgb_bar(p)
     MENU *p;
{
  int i, w;
  COL *col;
  
  col = coled_col(p);
  switch(p->n) {
  case COLED_RED:
    i = 0;
    w = col->rgb.red;
    break;
  case COLED_GREEN:
    i = 1;
    w = col->rgb.green;
    break;
  case COLED_BLUE:
    i = 2;
    w = col->rgb.blue;
    break;
  }
  XClearWindow(dsp, p->win);
  XResizeWindow(dsp, colorbarwin[coled_num(p)][i], w<1?1:w, COLBARH-BDW*3);
  XFillRectangle(dsp, p->win, gc0, BDW+w, BDW, 1, p->h-BDW*2);
}

/* update color
 * input: color_buf[current_pal*MAXCOLSET+n]
 *        pixtbl[n]
 */
void change_color(n)
     int n;			/* color number */
{
  XColor col;

  if (*(coltbl+n) & CM_PRIVATE) {
    calcol(&col, color_buf+n);
    col.pixel = pixtbl[n];
    XStoreColor(dsp, cmap, &col);
  }
  n %= MAXCOLSET;
  redraw_window(colmenu[n].win);
  if (coledopened[n]) {
    clear_color_digits(coledmn[n]);
    redraw_window(coledmn[n][COLED_RED].win);
    redraw_window(coledmn[n][COLED_GREEN].win);
    redraw_window(coledmn[n][COLED_BLUE].win);
    redraw_window(coledmn[n][COLED_NRED].win);
    redraw_window(coledmn[n][COLED_NGREEN].win);
    redraw_window(coledmn[n][COLED_NBLUE].win);
  }
  color_update_all();
}

static char *color_pushed = NULL;

void reset_color_pushed(n)
     int n;
{
  if (debug_mode)
    fprintf(stderr, "reset_color_pushed(%d)\n", n);
  if (color_pushed != NULL) {
    if (n < 0)
      bzero(color_pushed, MAXCOLSET);
    else
      color_pushed[n] = 0;
  }
}

int coledev(p, ev)
     MENU *p;
     XEvent *ev;
{
  int i;
  
  switch(ev->type) {
  case Expose:
    switch(p->n) {
    case COLED_COLOR:
      XFillRectangle(dsp, p->win, colgc[p->cursor],
		     ev->xexpose.x, ev->xexpose.y,
		     ev->xexpose.width, ev->xexpose.height);
      break;
    case COLED_RED:
    case COLED_GREEN:
    case COLED_BLUE:
      if (ev->xexpose.count == 0)
	draw_rgb_bar(p);
      break;
    }
    break;
  case ButtonPress:
    if (debug_mode)
      fprintf(stderr, "coledev: ButtonPress\n");
    switch(p->n) {
    case COLED_OK:
      if (color_pushed != NULL) {
	if (debug_mode)
	  fprintf(stderr, "coledev: clear color_pushed[%d]\n", coled_num(p));
	reset_color_pushed(coled_num(p));
      }
      unmap_coled_window(coled_num(p));
      return 1;
    case COLED_COLOR:
      XRaiseWindow(dsp, coledwin[coled_num(p)]);
      return 1;
    }
    if (color_pushed == NULL) {
      if (debug_mode)
	fprintf(stderr, "coledev: malloc color_pushed\n");
      color_pushed = malloc(MAXCOLSET);
      bzero(color_pushed, MAXCOLSET);
    }
    if (debug_mode)
      fprintf(stderr, "coledev: check color_pushed[%d]\n", coled_num(p));
    if (!color_pushed[coled_num(p)]) {
      color_pushed[coled_num(p)] = 1;
      if (debug_mode)
	fprintf(stderr, "coledev: undo_push_color(%d)\n",
		current_pal*MAXCOLSET+coled_num(p));
      undo_push_color(current_pal*MAXCOLSET+coled_num(p), 1);
    }
    if (debug_mode)
      fprintf(stderr, "coledev: press operation done\n");
    /* FALL THROUGH */
  case MotionNotify:
    if (!(coltbl[coled_num(p)] & CM_PRIVATE))
      return 1;
    switch(ev->type) {
    case MotionNotify:
      i = ev->xmotion.x;
      break;
    case ButtonPress:
      i = ev->xbutton.x;
      break;
    default:
      if (debug_mode)
	fprintf(stderr, "unknown colev %d\n", ev->type);
      break;
    }
    if (i < 0)
      i = 0;
    if (i > 255)
      i = 255;
    switch(p->n) {
    case COLED_RED:
      if (coled_col(p)->rgb.red != i) {
	colchanged = 1;
	coled_col(p)->rgb.red = i;
      }
      break;
    case COLED_GREEN:
      if (coled_col(p)->rgb.green != i) {
	colchanged = 1;
	coled_col(p)->rgb.green = i;
      }
      break;
    case COLED_BLUE:
      if (coled_col(p)->rgb.blue != i) {
	colchanged = 1;
	coled_col(p)->rgb.blue = i;
      }
      break;
    }
    change_color(coled_colnum(p));
    return 1;
  }
  return 0;
}

int colednev(p, ev)
     MENU *p;
     XEvent *ev;
{
  int i;
  KeySym key;
  char buf[16];
  
  switch(ev->type) {
  case KeyPress:
    i = XLookupString((XKeyEvent *)ev, buf, sizeof(buf)-1, &key, NULL);
    buf[i] = '\0';
    switch(key) {
    case XK_KP_Enter:
    case XK_Return:
      switch(p->n) {
      case COLED_NRED:
	undo_push_color(current_pal*MAXCOLSET+coled_num(p), 1);
	coled_col(p)->rgb.red = strtol(p->str, NULL, 0);
	break;
      case COLED_NGREEN:
	undo_push_color(current_pal*MAXCOLSET+coled_num(p), 1);
	coled_col(p)->rgb.green = strtol(p->str, NULL, 0);
	break;
      case COLED_NBLUE:
	undo_push_color(current_pal*MAXCOLSET+coled_num(p), 1);
	coled_col(p)->rgb.blue = strtol(p->str, NULL, 0);
	break;
      }
      colchanged = 1;
      change_color(coled_colnum(p));
      break;
    }
    break;
  }
  return 0;			/* continue to defalut event operation */
}

/* End of file */
