/* $Header: /home/yav/xpx/RCS/edit.c,v 1.32 1996/04/26 17:22:47 yav Exp $
 * xpx image edit
 * written by yav (UHD98984@pcvan.or.jp)
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>

#include "headers.h"
#ifdef HAVE_MATH_H
#include <math.h>
#endif
#include "xpx.h"
#include "work.h"
#include "editdef.h"
#include "menudef.h"
#include "cursdef.h"
#define PUBLIC_EDIT_C
#include "extern.h"


#define AUTOSAVETIME 30

#define EDMW	64
#define EDMH	24

#define EDITWINW 214
#define EDITWINH (EDITWINH2+8+(BDW+EDMH+BDW)+2+(BDW+EDMH+BDW)+4)
#define EDITWINH2 ((EDMH+BDW)*EDIT_PEN+BDW+8+(BDW+EDMH+BDW))

char rcsid_edit[] = "$Id: edit.c,v 1.32 1996/04/26 17:22:47 yav Exp $";


/* work */
static Window editfuncwin[3];
static int edit_mode[3] = {EDIT_PLOT, EDIT_GETCOLOR, EDIT_GETCOLOR};
static int area_mode = 0;
static int circle_mode = 0;
static int line_mode = 0;
static POS copypos0, copysrc0, copysrc1;
static AREA copydst;
static int penno[3] = {0, 0, 0};
static int penwidthtbl[] = {1, 2, 3, 5, 7, 0};


int edev();
int edev2();

char *edevpenstr(p)
     MENU *p;
{
  sprintf(p->str, "width %d", penwidthtbl[penno[get_top_menu(p)->cursor]]);
  return p->str;
}

int edevpen(p, ev)
     MENU *p;
     XEvent *ev;
{
  int i;
  
  switch (ev->type) {
  case ButtonPress:
    i = get_top_menu(p)->cursor;
    ++penno[i];
    if (!penwidthtbl[penno[i]])
      penno[i] = 0;
    redraw_window(p->win);
    return 1;
  }
  return 0;
}

#define IMASK (ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask)
#define EMSTRUC(num,name) \
{ (num), MenuModeMaskBorder,\
  0, (EDMH+BDW)*(num), EDMW, EDMH,\
  0, IMASK, 0,\
  edev, NULL, 0, 0, name}

static MENU menutbl[] = {
  {
    EDIT_dummy,	0,
    0, 0, EDMW, EDMH,
    0, ExposureMask, 0,
    NULL, NULL, 0, 0, "Button?"},
  EMSTRUC(EDIT_PLOT,	"plot"),
  EMSTRUC(EDIT_COPY,	"copy"),
  EMSTRUC(EDIT_FILL,	"boxfull"),
  EMSTRUC(EDIT_LINE,	"line"),
  EMSTRUC(EDIT_CIRCLE,	"circle"),
  EMSTRUC(EDIT_ELLIPSE,	"ellipse"),
  EMSTRUC(EDIT_PAINT,	"paint"),
  EMSTRUC(EDIT_GETCOLOR,"get"),
  EMSTRUC(EDIT_SCROLL,	"scroll"),
  EMSTRUC(EDIT_HOTSPOT,	"hotspot"),
  EMSTRUC(EDIT_GRID,	"grid"),
  EMSTRUC(EDIT_CANCEL,	"cancel"),
  {
    EDIT_ONGRID,	MenuModeMaskBorder,
    0, (EDMH+BDW)*EDIT_ONGRID+BDW+4, EDMW, EDMH,
    0, IMASK, 0,
    NULL, NULL, 0, 0, "on grid"},
  {
    EDIT_PEN,	MenuModeMaskBorder,
    0, (EDMH+BDW)*EDIT_PEN+BDW+4, EDMW, EDMH,
    0, IMASK, 0,
    edevpen, edevpenstr, 0, 16, NULL},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};

char *edev2str();
MENU editmenu2[] = {
  {
    EDIT2_UNDO,	MenuModeMaskBorder,
    4, 6+ BDW*2+4 + EDMH+BDW*2, 70, EDMH,
    0, IMASK, SouthWestGravity,
    edev2, edev2str, 0, 16, NULL},
  {
    EDIT2_IGNPIX,	0,
    4 + 70+BDW*2 + 8, 6+ BDW*2+4 + EDMH+BDW*2, 78, EDMH,
    0, ExposureMask, SouthWestGravity,
    NULL, NULL, 0, 0, "nocopypix:"},
  {
    EDIT2_IGNPIXN,	MenuModeMaskBorder,
    4 + 70+BDW*2 + 8 + 78, 6+ BDW*2+4 + EDMH+BDW*2, 40, EDMH,
    0, IMASK|KeyPressMask, SouthWestGravity,
    edev2, NULL, 0, 8, NULL},
  {
    EDIT2_AREA,	MenuModeMaskBorder,
    4, BDW*2+4, EDMW, EDMH,
    0, IMASK, SouthWestGravity,
    edev2, NULL, 0, 0, "Area"},
  {
    EDIT2_OK,	MenuModeMaskBorder,
    BDW*2+4, BDW*2+4, EDMW, EDMH,
    0, IMASK, SouthEastGravity,
    edev2, NULL, 0, 0, "OK"},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};
MENU *menutblp[3];

static int *ptsbuf = NULL;


int create_edit_window()
{
  int i;
  MENU *p;
  static char *titles[3] = {"Button1", "Button2", "Button3"};
  
  ptsbuf = (int*)malloc(sizeof(int)*8*(imgmaxw+imgmaxh));
  
  create_toplevel_window(&editwin, "edit", str_edit_geom, EDITWINW, EDITWINH);
  XSelectInput(dsp, editwin, ExposureMask);
  for (i = 0; i < 3; i++) {
    editfuncwin[i] =
      XCreateSimpleWindow(dsp, editwin,
			  4+(EDMW+BDW*2+4)*i, 0, EDMW+BDW*2, EDITWINH2,
			  0, fg, bg);
    XSelectInput(dsp, editfuncwin[i], ExposureMask);
    XMapWindow(dsp, editfuncwin[i]);
    p = (MENU *)malloc(sizeof(menutbl));
    memcpy(p, menutbl, sizeof(menutbl));
    p->str = titles[i];
    p->cursor = i;
    if (i == 0) {
      /* short cut key initial */
      (p+EDIT_PLOT)->str = "plOt";
      (p+EDIT_COPY)->str = "Copy";
      (p+EDIT_FILL)->str = "Boxfull";
      (p+EDIT_LINE)->str = "liNe";
      (p+EDIT_PAINT)->str = "Paint";
    }
    (p+edit_mode[i])->mode |= MenuModeMaskOn;
    menuwin_create(p, editfuncwin[i], 0, 0);
    menutblp[i] = p;
  }
  menuwin_create(editmenu2, editwin, 0, 0);
  /* Area edit menu */
  create_area_menu();
  return 0;
}

void map_edit_window()
{
  XMapRaised(dsp, editwin);
}

void unmap_edit_window()
{
  XUnmapWindow(dsp, editwin);
}

void close_edit_window()
{
  XDestroyWindow(dsp, editwin);
}

void area_mode_reset()
{
  area_flag = False;
  area_mode = line_mode = circle_mode = 0;
  copy_area_expose();
}

void edit_mode_change2(btn, mode)
     int btn;		/* 0:Button1 1:Button2 2:Button3 */
     int mode;
{
  MENU *p;
  
  area_mode_reset();
  p = menutblp[btn]+edit_mode[btn];
  if (mode != edit_mode[btn]) {
    p->mode &= ~MenuModeMaskOn;
    redraw_window(p->win);
    edit_mode[btn] = mode;
    p = menutblp[btn]+mode;
    p->mode |= MenuModeMaskOn;
    redraw_window(p->win);
  }
}

void edit_mode_change(n)
     int n;
{
  edit_mode_change2(0, n);
}

int edev(p, ev)
     MENU *p;
     XEvent *ev;
{
  switch(ev->type) {
  case ButtonPress:
    edit_mode_change2(get_top_menu(p)->cursor, p->n);
    return 1;
  }
  return 0;
}

void edit_undo()
{
  cursor_busy();
  undo_pull();
}

int edev2(p, ev)
     MENU *p;
     XEvent *ev;
{
  int i;
  KeySym key;
  char buf[16];
  
  switch(ev->type) {
  case ButtonPress:
    switch(p->n) {
    case EDIT2_UNDO:
      edit_undo();
      p->mode &= ~MenuModeMaskOn;
      redraw_window(p->win);
      return 1;
    case EDIT2_AREA:
      p->mode ^= MenuModeMaskOn;
      if (p->mode & MenuModeMaskOn)
	map_area_window();
      else
	unmap_area_window();
      redraw_window(p->win);
      return 1;
    case EDIT2_OK:
      p->mode &= ~MenuModeMaskOn;
      menu_stat_change(MENU_EDIT, 0);
      return 1;
    case EDIT2_IGNPIXN:
      p->mode ^= MenuModeMaskOn;
      nocopypixel_mode = p->mode & MenuModeMaskOn ? True : False;
      redraw_window(p->win);
      return 1;
    }
  case KeyPress:
    i = XLookupString((XKeyEvent *)ev, buf, sizeof(buf)-1, &key, NULL);
    buf[i] = '\0';
    switch(key) {
    case XK_KP_Enter:
    case XK_Return:
      i = strtol(p->str, NULL, 0);
      if (i >= 0 && i < 256) {
	nocopypixel = i;
	sprintf(p->str, "%d", i);
	p->mode |= MenuModeMaskOn;
	nocopypixel_mode = True;
      } else {
	p->mode &= ~MenuModeMaskOn;
	nocopypixel_mode = False;
      }
      redraw_window(p->win);
      return 1;
    }
    break;
  }
  return 0;
}

char *edev2str(p)
     MENU *p;
{
  switch(p->n) {
  case EDIT2_UNDO:
    if (undo_cnt >= MAXUNDO)
      strcpy(p->str, "Undo MAX");
    else
      sprintf(p->str, "Undo %d", undo_cnt);
    break;
  }
  return p->str;
}

void edit_undo_update()
{
  static int last_undo_cnt = -1;
  
  if (undo_cnt != last_undo_cnt) {
    redraw_window(editmenu2[EDIT2_UNDO].win);
    last_undo_cnt = undo_cnt;
  }
}

/*********************************
 * image edit function
 */

void area_img_expose(x, y, w, h)
     int x;
     int y;
     int w;
     int h;
{
  calc_img_area(&x, &y, &w, &h);
  img_expose(x, y, w, h);
}

void plot(x, y, c)
     int x;
     int y;
     int c;
{
  setpixelcolor(x, y, c);
  if (vimg != NULL)
    XClearArea(dsp, viewwin, x, y, 1, 1, True);
  img_expose(x*zoomfactor-imgofsx, y*zoomfactor-imgofsy,
	     zoomfactor, zoomfactor);
}

/* Window update */
void area_update(x, y, w, h)
     int x;
     int y;
     int w;
     int h;
{
  if (vimg != NULL)
    XClearArea(dsp, viewwin, x, y, w, h, True);
  area_img_expose(x, y, w, h);
  copy_area_expose();
}

void copy(dstx, dsty, srcx, srcy, w, h)
     int dstx;
     int dsty;
     int srcx;
     int srcy;
     int w;
     int h;
{
  if (w > 0 && h > 0) {
    undo_push_area(dstx, dsty, w, h);
    copy_area(dstx, dsty, srcx, srcy, w, h);
    area_update(dstx, dsty, w, h);
  }
}


void fill(x, y, w, h, c)
     int x;
     int y;
     int w;
     int h;
     int c;
{
  if (w > 0 && h > 0) {
    undo_push_area(x, y, w, h);
    fill_area(x, y, w, h, c);
    area_update(x, y, w, h);
  }
}

void edit_plot(x, y, pen)
     int x;
     int y;
     int pen;			/* pen width (pixel) */
{
  static int lastpen = -1;
  static int lastcol = -1;
  
  switch (pen) {
  case 1:
    if (current_col >= 0 && *(imgdata+y*imgmaxw+x) != current_col) {
      undo_push_plot(x, y, *(imgdata+y*imgmaxw+x), current_col);
      plot(x, y, current_col);
    }
    break;
  default:
    if (pen != lastpen || current_col != lastcol) {
      cursor_busy();
      undo_push_area(0, 0, imgfilew, imgfileh);
      lastpen = pen;
      lastcol = current_col;
    }
    fill_area(x-(pen-1)/2, y-(pen-1)/2, pen, pen, current_col);
    area_update(x-(pen-1)/2, y-(pen-1)/2, pen, pen);
    break;
  }
}

void edit_copy_and_fill(x, y, type, btn)
     int x;
     int y;
     int type;			/* event type */
     int btn;			/* 0:Button1 1:Button2 2:Button3 */
{
  switch (type) {
  case ButtonPress:
    switch(area_mode) {
    case 2:
      if (inarea(x, 1, copysrc0.x, copysrc1.x)&&
	  inarea(y, 1, copysrc0.y, copysrc1.y)) {
	/* area catch */
	copydst.x = x - copysrc0.x;
	copydst.y = y - copysrc0.y;
	copydst.w = copysrc1.x - copysrc0.x;
	copydst.h = copysrc1.y - copysrc0.y;
	area_mode = 3;
	break;
      }
      /* FALL THROUGH */
    case 0:
      /* area mark start */
      copypos0.x = x;
      copypos0.y = y;
      area_mode = 1;
      break;
    }
    break;
  case ButtonRelease:
    switch(area_mode) {
    case 3:
      /* paste */
      copy(area0.x, area0.y, copysrc0.x, copysrc0.y,
	   copysrc1.x - copysrc0.x, copysrc1.y - copysrc0.y);
      /* FALL THROUGH */
    case 1:
      /* area mark end */
      copysrc0.x = area0.x;
      copysrc0.y = area0.y;
      copysrc1.x = area0.w;
      copysrc1.y = area0.h;
      little_big(&copysrc0.x, &copysrc1.x);
      little_big(&copysrc0.y, &copysrc1.y);
      switch(edit_mode[btn]) {
      case EDIT_FILL:
	erase_last_area();
	area_flag = False;
	area_mode = 0;
	fill(copysrc0.x, copysrc0.y,
	     copysrc1.x-copysrc0.x, copysrc1.y-copysrc0.y, current_col);
	break;
      case EDIT_COPY:
	area_mode = 2;
	break;
      }
      break;
    }
    break;
  case MotionNotify:
    switch(area_mode) {
    case 1:
      /* area size update */
      if (x != area0.w || y != area0.h) {
	area0.w = x;
	area0.h = y;
	area0.x = copypos0.x;
	area0.y = copypos0.y;
	area_flag = True;
	copy_area_expose();
      }
      break;
    case 3:
      /* drug area */
      x -= copydst.x;
      if (x < 0)
	x = 0;
      if (x + copydst.w > imgfilew)
	x = imgfilew - copydst.w;
      y -= copydst.y;
      if (y < 0)
	y = 0;
      if (y + copydst.h > imgfileh)
	y = imgfileh - copydst.h;
      if (x != area0.x || y != area0.y) {
	area0.x = x;
	area0.y = y;
	area0.w = x + copydst.w;
	area0.h = y + copydst.h;
	copy_area_expose();
      }
      break;
    }
    break;
  }
}

#ifndef abs
#define abs(x) ((x)<0?-(x):(x))
#endif

void plots(p, n, pen)
     int *p;
     int n;
     int pen;			/* pen width (pixel) */
{
  int x, y, x0, y0, x1, y1;
  int xs, ys, xe, ye;
  int d0, d1;
  
  if (current_col < 0 || n <= 0)
    return;
  /* check update area */
  max_area(&x0, &y0, &x1, &y1, n, p);
  d0 = (pen-1) / 2;
  if ((x0 -= d0) < 0)
    x0 = 0;
  if ((y0 -= d0) < 0)
    y0 = 0;
  d1 = pen / 2;
  if ((x1 += d1) >= imgmaxw)
    x1 = imgmaxw - 1;
  if ((y1 += d1) >= imgmaxh)
    y1 = imgmaxh - 1;
  undo_push_area(x0, y0, x1-x0+1, y1-y0+1);
  while (n--) {
    xs = xe = *p++;
    ys = ye = *p++;
    if ((xs -= d0) < 0)
      xs = 0;
    if ((xe += d1) >= imgmaxw)
      xe = imgmaxw - 1;
    if ((ys -= d0) < 0)
      ys = 0;
    if ((ye += d1) >= imgmaxh)
      ye = imgmaxh - 1;
    for (y = ys; y <= ye; y++) {
      for (x = xs; x <= xe; x++) {
	setpixelcolor(x, y, current_col);
      }
    }
  }
  if (vimg != NULL)
    XClearArea(dsp, viewwin, x0, y0, x1-x0+1, y1-y0+1, True);
  img_expose(x0*zoomfactor-imgofsx, y0*zoomfactor-imgofsy,
	     (x1-x0+1)*zoomfactor, (y1-y0+1)*zoomfactor);
}

void edit_line(x, y, ev, btn)
     int x;
     int y;
     int ev;			/* event type */
     int btn;			/* 0:Button1 1:Button2 2:Button3 */
{
  int i;
  static int x0, y0, x1, y1;
  
  switch(ev) {
  case ButtonPress:
    x0 = x;
    y0 = y;
    x1 = y1 = -1;
    line_mode = 1;
    break;
  case ButtonRelease:
    if (line_mode == 1) {
      i = line(ptsbuf, x0, y0, x, y);
      mark_flag = False;
      mark_pts_expose();
      plots(ptsbuf, i, penwidthtbl[penno[btn]]);
      line_mode = 0;
    }
    break;
  case MotionNotify:
    if (line_mode == 1 && (x != x1 || y != y1)) {
      mark_flag = False;
      mark_pts_expose();
      i = line(ptsbuf, x0, y0, x, y);
      mark_pts_set(i, ptsbuf);
      mark_flag = True;
      mark_pts_expose();
      x1 = x;
      y1 = y;
    }
    break;
  }
}

void edit_circle_and_ellipse(x, y, ev, btn)
     int x;
     int y;
     int ev;			/* event type */
     int btn;			/* 0:Button1 1:Button2 2:Button3 */
{
  int i, rx, ry;
  static int x0, y0, x1, y1;
  
  switch(ev) {
  case ButtonPress:
    x0 = x;
    y0 = y;
    x1 = y1 = -1;
    circle_mode = 1;
    break;
  case ButtonRelease:
    if (circle_mode == 1) {
      rx = abs(x-x0);
      ry = abs(y-y0);
      if (edit_mode[btn] == EDIT_CIRCLE)
	ry = rx = ry>rx?ry:rx;
      if (rx > 0 && ry > 0) {
	if (edit_mode[btn] == EDIT_CIRCLE)
	  i = circle(ptsbuf, x0, y0, rx);
	else
	  i = ellipse(ptsbuf, x0, y0, rx, ry);
	mark_flag = False;
	mark_pts_expose();
	plots(ptsbuf, i, penwidthtbl[penno[btn]]);
      }
      area_flag = False;
      copy_area_expose();
      circle_mode = 0;
    }
    break;
  case MotionNotify:
    if (circle_mode == 1 && (x != x1 || y != y1)) {
      rx = abs(x-x0);
      ry = abs(y-y0);
      if (edit_mode[btn] == EDIT_CIRCLE)
	ry = rx = ry>rx?ry:rx;
      if (rx > 0 && ry > 0) {
	mark_flag = False;
	mark_pts_expose();
	if (edit_mode[btn] == EDIT_CIRCLE)
	  i = circle(ptsbuf, x0, y0, rx);
	else
	  i = ellipse(ptsbuf, x0, y0, rx, ry);
	mark_pts_set(i, ptsbuf);
	mark_flag = True;
	mark_pts_expose();
      }
      x1 = x;
      y1 = y;
    }
    break;
  }
}


void edit_paint(x, y, type)
     int x;
     int y;
     int type;
{
  switch(type) {
  case ButtonPress:
    cursor_busy();
    painted_pixel = *(imgdata+y*imgmaxw+x);
    if (painted_pixel != current_col) {
      undo_push_area(0, 0, imgfilew, imgfileh);
      paint(x, y);
      area_update(0, 0, imgfilew, imgfileh);
    }
    break;
  case ButtonRelease:
    break;
  }
}

void img_button_sub(x, y, type, btn, ox, oy)
     int x;
     int y;
     int type;
     int btn;			/* 0:Button1 1:Button2 2:Button3 */
     int ox;
     int oy;
{
  switch (edit_mode[btn]) {
  case EDIT_GETCOLOR:
    set_current_color(*(imgdata+y*imgmaxw+x));
    break;
  case EDIT_PLOT:
    edit_plot(x, y, penwidthtbl[penno[btn]]);
    break;
  case EDIT_COPY:
  case EDIT_FILL:
    edit_copy_and_fill(x, y, type, btn);
    break;
  case EDIT_LINE:
    edit_line(x, y, type, btn);
    break;
  case EDIT_CIRCLE:
  case EDIT_ELLIPSE:
    edit_circle_and_ellipse(x, y, type, btn);
    break;
  case EDIT_PAINT:
    edit_paint(x, y, type);
    break;
  case EDIT_SCROLL:
    switch(type) {
    case ButtonPress:
      /* set background scroll */
      if (ox < imgwinwidth/3)
	scroll_ax = -1;
      if (ox >= imgwinwidth*2/3)
	scroll_ax = 1;
      if (oy < imgwinheight/3)
	scroll_ay = -1;
      if (oy >= imgwinheight*2/3)
	scroll_ay = 1;
      break;
    case ButtonRelease:
      /* reset background scroll */
      scroll_dx = scroll_dy = 0;
      scroll_ax = scroll_ay = 0;
      break;
    }
    break;
  case EDIT_GRID:
    if (type == ButtonPress) {
      grid_ofsx = x % grid_size;
      grid_ofsy = y % grid_size;
      set_image_size(-1, -1);
      area_mode_reset();
    }
    break;
  case EDIT_HOTSPOT:
    if (type == ButtonPress) {
      if (x == hotspotx && y == hotspoty)
	x = y = -1;
      hotspotx = x;
      hotspoty = y;
      set_image_size(-1, -1);
    }
    /* continue to next case */
  case EDIT_CANCEL:
  default:
    if (type == ButtonPress)
      area_mode_reset();
    mark_pts_expose();
    return;
  }
}

void img_button(type, ox, oy, button, st)
     int type;
     int ox;
     int oy;
     int button;
     unsigned int st;
{
  int x, y, dx, dy, btn;
  
  x = (ox + imgofsx) / zoomfactor;
  y = (oy + imgofsy) / zoomfactor;
  switch(button) {
  case Button1:
    btn = 0;
    break;
  case Button2:
    btn = 1;
    break;
  case Button3:
    btn = 2;
    break;
  }
  if ((menutblp[btn]+EDIT_ONGRID)->mode & MenuModeMaskOn) {
    dx = (x - grid_ofsx) % grid_size;
    x -= dx;
    if (dx > grid_size/2)
      x += grid_size;
    dy = (y - grid_ofsy) % grid_size;
    y -= dy;
    if (dy > grid_size/2)
      y += grid_size;
  }
  if (x < 0)
    x = 0;
  if (x >= imgfilew)
    x = imgfilew;
  if (y < 0)
    y = 0;
  if (y >= imgfileh)
    y = imgfileh;
  if (x != curx) {
    curx = x;
    redraw_window(cursmenu[CURS_CURX].win);
  }
  if (y != cury) {
    cury = y;
    redraw_window(cursmenu[CURS_CURY].win);
  }
  img_button_sub(x, y, type, btn, ox, oy);
}

void edit_event(ev)
     XEvent *ev;
{
  int x, y, button;
  static int savecnt = 0;
  
  if (get_event_window(ev) != imgwin)
    return;
  switch (ev->type) {
  case MotionNotify:
    x = ev->xmotion.x;
    y = ev->xmotion.y;
    if (ev->xmotion.state & Button1Mask)
      img_button(ev->type, x, y, Button1);
    if (ev->xmotion.state & Button2Mask)
      img_button(ev->type, x, y, Button2);
    if (ev->xmotion.state & Button3Mask)
      img_button(ev->type, x, y, Button3);
    break;
  case ButtonRelease:
    if (++savecnt >= AUTOSAVETIME) {
      autosave();
      savecnt = 0;
    }
  case ButtonPress:
    button = ev->xbutton.button;
    img_button(ev->type, ev->xbutton.x, ev->xbutton.y, ev->xbutton.button);
    break;
  }
}

/* End of file */
