/* $Header: /home/yav/xpx/RCS/ellipse.c,v 1.5 1995/11/23 16:28:39 yav Exp $
 * ellipse
 * written by yav (UHD98984@pcvan.or.jp)
 * Reference:
 * Algorithm dictionary by Haruhiko Okumura (PAF01002@niftyserve.or.jp)
 */

char rcsid_ellipse[] = "$Id: ellipse.c,v 1.5 1995/11/23 16:28:39 yav Exp $";

#define DOT(x,y) (*pp++ = (x), *pp++ = (y))

/* return number of points */
int ellipse(pp, xc, yc, rx, ry)
     int *pp;
     int xc;
     int yc;
     int rx;
     int ry;
{
  int x, x1, y, y1, r, pts;

  pts = y = 0;
  if (rx > ry) {
    x = r = rx;
    while (x >= y) {
      x1 = ((long)x * ry) / rx;
      y1 = ((long)y * ry) / rx;
      DOT(xc + x -1, yc + y1 -1);
      DOT(xc + x -1, yc - y1);
      DOT(xc - x, yc + y1 -1);
      DOT(xc - x, yc - y1);
      DOT(xc + y -1, yc + x1 -1);
      DOT(xc + y -1, yc - x1);
      DOT(xc - y, yc + x1 -1);
      DOT(xc - y, yc - x1);
      pts += 8;
      if ((r -= (y++ << 1) - 1) < 0)
	r += (x-- - 1) << 1;
    }
  } else {
    x = r = ry;
    while (x >= y) {
      x1 = ((long)x * rx) / ry;
      y1 = ((long)y * rx) / ry;
      DOT(xc + x1 -1, yc + y -1);
      DOT(xc + x1 -1, yc - y);
      DOT(xc - x1, yc + y -1);
      DOT(xc - x1, yc - y);
      DOT(xc + y1 -1, yc + x -1);
      DOT(xc + y1 -1, yc - x);
      DOT(xc - y1, yc + x -1);
      DOT(xc - y1, yc - x);
      pts += 8;
      if ((r -= (y++ << 1) - 1) < 0)
	r += (x-- - 1) << 1;
    }
  }
  return pts;
}

/* End of file */
