/* $Header: /home/yav/xpx/RCS/file.c,v 1.62 1996/04/23 10:58:05 yav Exp $
 * xpx file menu
 * written by yav (UHD98984@pcvan.or.jp)
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>

#include "headers.h"
#include "xpx.h"
#include "work.h"
#include "icondef.h"
#include "infodef.h"
#define PUBLIC_FILE_C
#include "extern.h"

# ifdef HAVE_SYS_WAIT_H
#  include <sys/wait.h>
# endif

#define FILEWINWIDTH	320
#define FILEWINHEIGHT	320

#define MAXFILE	1024
#define MAXFILENAME	64

#define PATHX	8
#define PATHY	8
#define PATHW	300
#define PATHH	24

#define NAMEX	160
#define NAMEY	100
#define NAMEW	140
#define NAMEH	PATHH

#define DIRSLOTMAX	12
#define FILESLOTMAX	14	/* >= DIRSLOTMAX+1 */

#define SCROLLX		(8-BDW)
#define SCROLLY		40
#define SCROLLW		128
#define SCROLLH		20
#define DIRSLOTX	(SCROLLX+BDW)
#define DIRSLOTY	(SCROLLY+SCROLLH+BDW*2)
#define DIRSLOTW	SCROLLW
#define DIRSLOTH	18

#define FILEMENUX	196
#define FILEMENUY	160
#define FILEMENUW	64
#define FILEMENUH	20

#define SLIDERW	16
#define SLIDERH	(DIRSLOTH*DIRSLOTMAX)

#define COLNMX	0
#define COLNMY	0
#define COLNMW	112
#define COLNMH	16
#define IMGNMX	COLNMX+COLNMW+8
#define IMGNMY	COLNMY
#define IMGNMW	COLNMW
#define IMGNMH	COLNMH

char rcsid_file[] = "$Id: file.c,v 1.62 1996/04/23 10:58:05 yav Exp $";

static Window file2win;
static int select_slot;
static char *filenamebuf;
static char current_path[MAXPATH];
static char current_name[MAXFILENAME];
static int files_count;
static int scroll_range;
static int scroll_pos;
static int slotindex[FILESLOTMAX];
static int file_scroll_speed;
static char *rcfile = ".xpxrc";

#define F_IMG	(1<<0)
#define F_COL	(1<<1)
#define F_ALL	(F_IMG|F_COL)

typedef struct {
  char suffix[8];
  int mode;
  int (*readroutine)();
  int (*writeroutine)();
  char *decoder;
  char *encoder;
} FTYPE;

#define FTYPEMAX 32
static FTYPE *file_type_tbl = NULL;
static FTYPE default_file_type[] = {
  {".cbb",	F_IMG,	rd_cbb,	wr_cbb,	NULL,		NULL},
  {".csb",	F_IMG,	rd_csb,	NULL,	NULL,		NULL},
  {".ccb",	F_COL,	rd_ccb,	wr_ccb,	NULL,		NULL},
  {".cxb",	F_COL,	rd_cxb,	wr_cxb, NULL,		NULL},
  {".kcf",	F_COL,	rd_kcf,	wr_kcf, NULL,		NULL},
  {".cel",	F_IMG,	rd_cel,	wr_cel, NULL,		NULL},
  {".pbm",	F_ALL,	rd_pnm,	NULL,	NULL,		NULL},
  {".pgm",	F_ALL,	rd_pnm,	NULL,	NULL,		NULL},
  {".ppm",	F_ALL,	rd_pnm,	wr_ppm,	NULL,		NULL},
  {".mag",	F_ALL,	rd_mag,	wr_mag,	NULL,		NULL},
  {".xbm",	F_IMG,	rd_xbm,	wr_xbm,	NULL,		NULL},	
  {".gif",	F_ALL,	rd_pnm,	wr_ppm,	"giftoppm",	"ppmtogif"},	
  {".tim",	F_ALL,	rd_tim,	wr_tim,	NULL,		NULL},
  {".nbn",	F_ALL,	rd_nbn,	NULL,	NULL,		NULL},
  {".cls",	F_COL,	rd_cls,	NULL,	NULL,		NULL},
  {"",		0,	NULL,	NULL,	NULL,		NULL}
};

#define FILE_PATH	0
#define FILE_NAME	1
#define FILE_OPEN	2
#define FILE_SAVE	3
#define FILE_MASK	4
#define FILE_REMOVE	5
#define FILE_DUMMY2	6
#define FILE_OK		7
#define FILE_SLIDER	8

int fileev();
int slotev();
int slotev2();
void scroll_down();
void scroll_up();

#define IMASK (ExposureMask|EnterWindowMask|LeaveWindowMask|\
	       ButtonPressMask|ButtonReleaseMask)
static MENU filemenu[] = {
  {
    FILE_PATH,	MenuModeMaskBorder,
    PATHX, PATHY, PATHW, PATHH,
    0, ExposureMask|EnterWindowMask|LeaveWindowMask|KeyPressMask, 0,
    fileev, NULL, 0, MAXPATH, NULL},
  {
    FILE_NAME,	MenuModeMaskBorder,
    NAMEX, NAMEY, NAMEW, NAMEH,
    0, ExposureMask|EnterWindowMask|LeaveWindowMask|KeyPressMask, 0,
    fileev, NULL, 0, 64, NULL},
  {
    FILE_OPEN,	MenuModeMaskBorder,
    FILEMENUX, FILEMENUY+(FILEMENUH+BDW)*0, FILEMENUW, FILEMENUH,
    0, IMASK, 0,
    fileev, NULL, 0, 0, "Open"},
  {
    FILE_SAVE,	MenuModeMaskBorder,
    FILEMENUX, FILEMENUY+(FILEMENUH+BDW)*1, FILEMENUW, FILEMENUH,
    0, IMASK, 0,
    fileev, NULL, 0, 0, "Save"},
  {
    FILE_MASK,	MenuModeMaskBorder|MenuModeMaskOn,
    FILEMENUX, FILEMENUY+(FILEMENUH+BDW)*2, FILEMENUW, FILEMENUH,
    0, ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    fileev, NULL, 0, 0, "Mask"},
  {
    FILE_REMOVE,	MenuModeMaskBorder,
    FILEMENUX, FILEMENUY+(FILEMENUH+BDW)*3, FILEMENUW, FILEMENUH,
    0, IMASK, 0,
    fileev, NULL, 0, 0, "Remove"},
  {
    FILE_DUMMY2,	MenuModeMaskBorder,
    FILEMENUX, FILEMENUY+(FILEMENUH+BDW)*4, FILEMENUW, FILEMENUH,
    0, ExposureMask, 0,
    NULL, NULL, 0, 0, "----"},
  {
    FILE_OK,	MenuModeMaskBorder,
    FILEMENUX, FILEMENUY+(FILEMENUH+BDW)*5, FILEMENUW, FILEMENUH,
    0, IMASK, 0,
    fileev, NULL, 0, 0, "OK"},
  {
    FILE_SLIDER,	MenuModeMaskBorder,
    DIRSLOTX+DIRSLOTW+BDW*2, DIRSLOTY, SLIDERW, SLIDERH,
    0, ExposureMask|ButtonPressMask, 0,
    NULL, NULL, 0, 0, NULL},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};
#undef IMASK

static MENU *fileslot;

#define DIRSLOT_UP	0
#define DIRSLOT_DOWN	1
#define IMASK (ExposureMask|EnterWindowMask|LeaveWindowMask|\
	       ButtonPressMask|ButtonReleaseMask)
static MENU slotwin[] = {
  {
    DIRSLOT_UP,	MenuModeMaskBorder,
    SCROLLX, SCROLLY, SCROLLW, SCROLLH,
    0, IMASK, 0,
    slotev2, NULL, 0, 0, NULL},
  {
    DIRSLOT_DOWN,	MenuModeMaskBorder,
    SCROLLX, SCROLLY+SCROLLH+BDW*4+DIRSLOTH*DIRSLOTMAX, SCROLLW, SCROLLH,
    0, IMASK, 0,
    slotev2, NULL, 0, 0, NULL},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};
#undef IMASK

#define NAMEMENU_IMAGE	0
#define NAMEMENU_COLOR	1

char *namemenu_str();

static MENU namemenu[] = {
  {
    NAMEMENU_IMAGE,	MenuModeMaskBorder,
    IMGNMX, IMGNMY, IMGNMW, IMGNMH,
    0, ExposureMask, 0,
    NULL, namemenu_str, 0, 0, NULL},
  {
    NAMEMENU_COLOR,	MenuModeMaskBorder,
    COLNMX, COLNMY, COLNMW, COLNMH,
    0, ExposureMask, 0,
    NULL, namemenu_str, 0, 0, NULL},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};

char *namemenu_str(p)
     MENU *p;
{
  switch(p->n) {
  case NAMEMENU_IMAGE:
    return filename(imgfilename);
  case NAMEMENU_COLOR:
    return filename(colfilename);
  }
  /* NOT REACHED */
  return NULL;
}

int sliderev(p, ev)
     MENU *p;
     XEvent *ev;
{
  int i, rx, ry, cx, cy;
  unsigned int key;
  Window rw, cw;
  static int dy, sy;
  
  switch(ev->type) {
  case ButtonPress:
    dy = p->y + ev->xbutton.y;
    dy = ev->xbutton.y_root;
    sy = scroll_pos;
    return 1;
    break;
  case ButtonRelease:
    return 1;
    break;
  case MotionNotify:
    XQueryPointer(dsp, ev->xmotion.window, &rw, &cw, &rx, &ry, &cx, &cy, &key);
    i = ((ry - dy)*scroll_range)/(SLIDERH-p->h) + sy;
    if (i > scroll_pos)
      scroll_up(i - scroll_pos);
    else if (i < scroll_pos)
      scroll_down(scroll_pos - i);
    break;
  }
  return 0;
}

#define IMASK	(ExposureMask|ButtonPressMask|ButtonReleaseMask|\
		 PointerMotionHintMask|ButtonMotionMask)

static MENU slidermenu[] = {
  {
    0,	MenuModeMaskBorder,
    0, 0, SLIDERW-BDW*2, 1,
    0, IMASK, 0,
    sliderev, NULL, 0, 0, NULL},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};
#undef IMASK

void resize_slider()
{
  int movearea, fcnt;
  MENU *p;
  
  fcnt = files_count < DIRSLOTMAX ? DIRSLOTMAX : files_count;
  p = slidermenu+0;
  p->h = ((SLIDERH-BDW*2)*DIRSLOTMAX)/fcnt;
  if (p->h < p->w)
    p->h = p->w;
  movearea = (SLIDERH-BDW*2) - p->h;
  p->y = 0;
  fcnt -= DIRSLOTMAX;
  if (fcnt > 0)
    p->y = (movearea*scroll_pos)/fcnt/DIRSLOTH;
  XMoveResizeWindow(dsp, p->win, p->x, p->y, p->w, p->h);
}

int get_filetype_max(
#if NeedFunctionPrototypes
		     void
#endif
		     )
{
  int i;
  
  for (i = 0; i < FTYPEMAX; i++) {
    if (file_type_tbl[i].suffix[0] == '\0')
      break;
  }
  return i;
}

int is_supported_suffix(
#if NeedFunctionPrototypes
			char *name)
#else
     name)
     char *name;
#endif
{
  int i;
  int len, suflen;
  
  len = strlen(name);
  i = get_filetype_max();
  while (--i >= 0) {
    suflen = strlen(file_type_tbl[i].suffix);
    if ((len - suflen >= 0) &&
	(strncmp(name+len-suflen, file_type_tbl[i].suffix, suflen) == 0))
      return 1;
  }
  return 0;
}

int select_suffix(
#if NeedFunctionPrototypes
		  char *buf, int len, int n)
#else
     buf, len, n)
     char *buf;
     int len;
     int n;
#endif
{
  int i, j, r;
  char *p, *p2;
  
  p = buf;
  r = 0;
  for (i = 0; i < n && *p; i++) {
    j = strlen(p);
    if ((j && *(p+j-1) == '/')||
	is_supported_suffix(p))
      r++;
    else
      *p = '\0';
    p += len;
  }
  p = p2 = buf;
  for (i = 0; i < n; i++) {
    if (*p) {
      if (p != p2)
	memcpy(p2, p, len);
      p2 += len;
    }
    p += len;
  }
  while (p2 != p) {
    *p2 = '\0';
    p2 += len;
  }
  return r;
}

/*
 * return number of file (0 is error!)
 */
int get_filenames()
{
  int i, n;
  
  n = get_dir(current_path, filenamebuf, MAXFILENAME, MAXFILE);
  for (i = n; i < MAXFILE; i++)
    *(filenamebuf+i*MAXFILENAME) = '\0';
  if (filemenu[FILE_MASK].mode & MenuModeMaskOn)
    n = select_suffix(filenamebuf, MAXFILENAME, n);
  redraw_window(filemenu[FILE_PATH].win);
  files_count = n;
  scroll_range = (n-DIRSLOTMAX)*DIRSLOTH;
  if (scroll_range < 0)
    scroll_range = 0;
  return n;
}

char *slotwin_strfunc(p)
     MENU *p;
{
  return filenamebuf+slotindex[p->n]*MAXFILENAME;
}

void redraw_fileslot()
{
  int i;
  MENU *p;
  
  p = fileslot;
  for (i = 0; i < FILESLOTMAX; i++) {
    XMoveWindow(dsp, p->win, p->x, p->y);
    redraw_window(p->win);
    p++;
  }
}

void set_slotmode(n)
     int n;
{
  if (slotindex[n] == select_slot)
    (fileslot+n)->mode |= MenuModeMaskOn;
  else
    (fileslot+n)->mode &= ~MenuModeMaskOn;
}

void init_fileslot_pos()
{
  int i, y;
  int startindex;
  MENU *p;
  
  p = fileslot;
  startindex = scroll_pos / DIRSLOTH;
  y = - (scroll_pos % DIRSLOTH);
  for (i = 0; i < FILESLOTMAX; i++) {
    slotindex[i] = startindex+i;
    p->x = 0;
    p->y = y;
    y += DIRSLOTH;
    set_slotmode(i);
    p++;
  }
}


int create_file_window()
{
  int i;
  MENU *p;
  XSetWindowAttributes attr;
  
  filenamebuf = malloc(MAXFILE*MAXFILENAME);
  create_toplevel_window(&filewin, "file", str_file_geom,
			 FILEWINWIDTH, FILEWINHEIGHT);
  menuwin_create(filemenu, filewin, 0, 0);
  file2win = XCreateSimpleWindow(dsp, filewin, DIRSLOTX, DIRSLOTY,
				 DIRSLOTW, DIRSLOTH*DIRSLOTMAX,
				 BDW, border_color, bg);
  XMapRaised(dsp, file2win);
  fileslot = (MENU *)malloc(sizeof(MENU)*(FILESLOTMAX+1));
  p = fileslot;
  for (i = 0; i < FILESLOTMAX; i++) {
    bzero(p, sizeof(*p));
    p->n = i;
    p->w = DIRSLOTW;
    p->h = DIRSLOTH;
    p->mode = MenuModeMaskLeft;
    p->im = ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask;
    p->event = slotev;
    p->strfunc = slotwin_strfunc;
    p++;
  }
  p->n = -1;
  select_slot = 0;
  scroll_pos = 0;
  init_fileslot_pos();
  menuwin_create(fileslot, file2win, 0, 0);
  menuwin_create(slotwin, filewin, BDW, 0);
  attr.background_pixmap = hatch_pixmap;
  XChangeWindowAttributes(dsp, filemenu[FILE_SLIDER].win, CWBackPixmap, &attr);
  menuwin_create(slidermenu, filemenu[FILE_SLIDER].win, 0, 0);
  
  change_directory("");		/* get current */
  return 0;
}

void map_file_window()
{
  XMapRaised(dsp, filewin);
}

void unmap_file_window()
{
  XUnmapWindow(dsp, filewin);
}

void close_file_window()
{
  XDestroyWindow(dsp, filewin);
  free(filenamebuf);
}

char *get_parent_pathname(path)
     char *path;
{
  char *p;
  
  p = strrchr(path, '/');
  if (p != NULL) {
    if (p == path)
      p++;
    *p = '\0';
  }
  return path;
}

void set_current_name(name)
     char *name;
{
  strcpy(current_name, name);
  strcpy(filemenu[FILE_NAME].str, name);
  filemenu[FILE_NAME].cursor = strlen(current_name);
  redraw_window(filemenu[FILE_NAME].win);
}

void set_select_slot_name(
#if NeedFunctionPrototypes
			  void
#endif
			  )
{
  set_current_name(filenamebuf+(select_slot)*MAXFILENAME);
}

void rescan_disp_fileslot(
#if NeedFunctionPrototypes
			  void
#endif
			  )
{
  int i;
  
  cursor_busy();
  i = get_filenames();
  if (select_slot >= i)
    select_slot = i-1;
  scroll_pos = select_slot*DIRSLOTH - (DIRSLOTMAX*DIRSLOTH)/2;
  if (scroll_pos < 0)
    scroll_pos = 0;
  else if (scroll_pos >= scroll_range)
    scroll_pos = scroll_range;
  init_fileslot_pos();
  resize_slider();
  redraw_fileslot();
}

int change_directory(dir)
     char *dir;
{
  int i;
  char buf[MAXPATH];
  char buf2[MAXPATH];
  
  switch(*dir) {
  case '\0':
    /* current working directory pathname */
    get_current_dir(buf);
    break;
  case '/':
    /* absolute pathname */
    strcpy(buf, dir);
    break;
  default:
    /* relative pathname */
    strcpy(buf, current_path);
    strcpy(buf2, dir);
    i = strlen(buf2);
    if (i && buf2[i-1] == '/')
      buf2[i-1] = '\0';
    if (strcmp(buf2, "..") == 0) {
      get_parent_pathname(buf);
    } else if (strcmp(buf2, ".") != 0) {
      i = strlen(buf);
      if (i && buf[i-1] != '/')
	strcat(buf, "/");
      strcat(buf, buf2);
    }
  }
  if (get_dir(buf, buf2, sizeof(buf2), 1)) {
    strcpy(current_path, buf);
    strcpy(filemenu[FILE_PATH].str, buf);
    filemenu[FILE_PATH].cursor = strlen(filemenu[FILE_PATH].str);
    redraw_window(filemenu[FILE_PATH].win);
    select_slot = 0;
    scroll_pos = 0;
    rescan_disp_fileslot();
    set_select_slot_name();
    return 0;
  }
  return 1;
}

void set_imgfilename(name)
     char *name;
{
  strcpy(imgfilename, name);
  redraw_window(namemenu[NAMEMENU_IMAGE].win);
  redraw_window(infomenu[INFOMENU_IMGFILE].win);
}

void set_colfilename(name)
     char *name;
{
  strcpy(colfilename, name);
  redraw_window(namemenu[NAMEMENU_COLOR].win);
  redraw_window(infomenu[INFOMENU_COLFILE].win);
  redraw_window(infomenu[INFOMENU_COLCOUNT].win);
}

void create_filename_window(win, x, y)
     Window win;
     int x;
     int y;
{
  topmenuwin_create(namemenu, x, y);
}

char *skip_space(p)
     char *p;
{
  while (*p && (*p == ' ' || *p == '\t' || *p == '\n'))
    p++;
  return p;
}

/* Search matching string in structures
 * structure first member must be (char *).
 * if not found matching string, return NULL
 */
char *match_struct(tbl, len, p)
     char *tbl;			/* structure list pointer */
     int len;			/* size of a structure */
     char *p;			/* string */
{
  char *s;

  while ((s = *((char **)tbl)) != NULL) {
    if (strncmp(p, s, strlen(s)) == 0)
      return tbl;
    tbl += len;			/* get next structure address */
  }
  return NULL;			/* not found */
}

/* if not found matching string, return -1 */
int match_string(tbl, p)
     char *tbl[];
     char *p;
{
  int i;
  
  for (i = 0; tbl[i] != NULL; i++) {
    if (strncmp(p, tbl[i], strlen(tbl[i])) == 0)
      return i;
  }
  return -1;			/* not found */
}

char *get_string(
#if NeedFunctionProtorypes
		 char str[], char *p, int n)
#else
     str, p, n)
     char str[];
     char *p;
     int n;
#endif
{
  int i;
  int quote;
  
  p = skip_space(p);
  quote = i = 0;
  if (*p == '"' || *p == '\'')
    quote = *p++;
  while (i < n-1 && *p) {
    if (*p == quote) {
      p++;
      break;
    }
    if (!quote && (*p == ' ' || *p == '\t'))
      break;
    str[i++] = *p++;
  }
  str[i] = '\0';
  return p;
}

/* Parse string in structure
 * structure first member must be (char *).
 * if not found matching string, return NULL
 */
#if NeedFunctionPrototypes
void *parse_str2(void *tbl, int len, char **p)
#else
     char *parse_str2(
		      tbl, len, p)
     char *tbl;			/* structure list pointer */
     int len;			/* size of one structure */
     char **p;			/* string */
#endif
{
  char *r;
  char buf[256];
  
  *p = get_string(buf, *p, sizeof(buf));
  if (strcmp(buf, "None") == 0 || strcmp(buf, "-") == 0)
    return NULL;
  r = match_struct(tbl, len, buf);
  if (r == NULL) {
    error("parse ``%s'' unknown!", buf);
    *p += strlen(*p);
  }
  return r;
}

/* type */
typedef struct _MODETBL {
  char *symbol;
  int mode;
} MODETBL;

static MODETBL modetbll[] = {
  {"color", F_COL},
  {"image", F_IMG},
  {"all", F_ALL},
  {NULL, 0}
};

typedef struct _FUNCTBL {
  char *symbol;
  int (*func)();
} FUNCTBL;

/* read routine */
static FUNCTBL rdfunc[] = {
  {"ccb", rd_ccb},
  {"cbb", rd_cbb},
  {"csb", rd_csb},
  {"cxb", rd_cxb},
  {"kcf", rd_kcf},
  {"cel", rd_cel},
  {"pnm", rd_pnm},
  {"ppm", rd_pnm},
  {"xbm", rd_xbm},
  {"mag", rd_mag},
  {"tim", rd_tim},
  {"nbn", rd_nbn},
  {"cls", rd_cls},
  {NULL, NULL}
};

/* write routine */
static FUNCTBL wrfunc[] = {
  {"ccb", wr_ccb},
  {"cbb", wr_cbb},
  {"cxb", wr_cxb},
  {"kcf", wr_kcf},
  {"cel", wr_cel},
  {"ppm", wr_ppm},
  {"xbm", wr_xbm},
  {"mag", wr_mag},
  {"tim", wr_tim},
  {NULL, NULL}
};

int parse_ftype(
#if NeedFunctionPrototypes
		char *p)
#else
     p)
     char *p;
#endif
{
  int i;
  FTYPE *pp;
  FUNCTBL *funcp;
  MODETBL *modep;
  char buf[256];
  
  i = get_filetype_max();
  pp = file_type_tbl + i;
  p = get_string(pp->suffix, p, sizeof(pp->suffix));
  if (!*p)
    return 1;
  modep = parse_str2(modetbll, sizeof(*modetbll), &p);
  pp->mode = (modep != NULL) ? modep->mode : 0;
  funcp = parse_str2(rdfunc, sizeof(*rdfunc), &p);
  pp->readroutine = (funcp != NULL) ? funcp->func : NULL;
  funcp = parse_str2(wrfunc, sizeof(*wrfunc), &p);
  pp->writeroutine = (funcp != NULL) ? funcp->func : NULL;
  pp->decoder = NULL;
  p = get_string(buf, p, sizeof(buf));
  if (buf[0]) {
    pp->decoder = (char *)malloc(strlen(buf)+1);
    strcpy(pp->decoder, buf);
  }
  pp->encoder = NULL;
  p = get_string(buf, p, sizeof(buf));
  if (buf[0]) {
    pp->encoder = (char *)malloc(strlen(buf)+1);
    strcpy(pp->encoder, buf);
  }
  return 0;
}

int parse_option_configuration(
#if NeedFunctionProtorypes
			       char *p)
#else
     p)
     char *p;
#endif
{
  int i;
  char *bufp;
  char **argv;
  char buf[1024];
  char *av[64];
  
  i = 0;
  bufp = buf;
  while (i < 64-1) {
    p = get_string(bufp, p, sizeof(buf)-(bufp-buf));
    if (!*bufp)
      break;
    av[i++] = bufp;
    bufp += strlen(bufp) + 1;
    if (bufp >= buf+sizeof(buf))
      break;
  }
  av[i] = NULL;
  argv = av;
  return parse_option(&i, &argv);
}

static char *section_name[] = {"*end", "*file", "*window", "*option", NULL};

typedef struct _WINGEOMTBL {
  char *symbol;
  char *geom;
  Window *win;
} WINGEOMTBL;

static WINGEOMTBL wintbl[] = {
  {"file", str_file_geom, &filewin},
  {"info", str_info_geom, &infowin},
  {"edit", str_edit_geom, &editwin},
  {NULL, NULL, NULL}
};


int parse_window_configuration(
#if NeedFunctionProtorypes
			       char *p)
#else
     p)
     char *p;
#endif
{
  WINGEOMTBL *wp;
  char buf[256];
  
  wp = parse_str2(wintbl, sizeof(*wintbl), &p);
  if (wp == NULL)
    return -1;
  get_string(buf, p, sizeof(buf));
  strncpy(wp->geom, buf, 32);
  return 0;
}


int read_config_file(
#if NeedFunctionPrototypes
		     char *name)
#else
     name)
     char *name;
#endif
{
  int i;
  int section;			/* 0:None 1:file 2:window 3:option */
  FILE *fp;
  char buf[1024];
  
  fp = fopen(name, "r");
  if (fp == NULL)
    return 1;
  section = 0;
  while (fgets(buf, sizeof(buf), fp) != NULL) {
    i = strlen(buf);
    if (i && buf[i-1] == '\n')
      buf[i-1] = '\0';
    if (buf[0] == '#' || buf[0] == '\0')
      continue;
    if (buf[0] == '*') {
      i = match_string(section_name, buf);
      if (i < 0)
	i = 0;
      section = i;
      continue;
    }
    switch(section) {
    case 1:
      if (parse_ftype(buf))
	error("file type parse error ``%s''", buf);
      break;
    case 2:
      parse_window_configuration(buf);
      break;
    case 3:
      parse_option_configuration(buf);
      break;
    }
  }
  fclose(fp);
  return 0;
}

/*
 * return 0: no error!
 * Caution! This routine is called before XOpenDisplay.
 */
int read_config(
#if NeedFunctionPrototypes
		void
#endif
		)
{
  int i;
  char *p;
  char buf[MAXPATH];
  
  file_type_tbl = (FTYPE *)malloc(sizeof(FTYPE)*FTYPEMAX);
  if (file_type_tbl == NULL) {
    error("more core!");
    return 1;
  }
  bzero(file_type_tbl, sizeof(FTYPE)*FTYPEMAX);
  for (i = 0; default_file_type[i].suffix[0]; i++)
    file_type_tbl[i] = default_file_type[i];
  p = getenv("HOME");
  if (p != NULL) {
    sprintf(buf, "%s/%s", p, rcfile);
    read_config_file(buf);
  }
  read_config_file(rcfile);
  return 0;
}

void gen_geometry_string(
#if NeedFunctionProtorypes
			 char *buf, Window win)
#else
     buf, win)
     char *buf;
     Window win;
#endif
{
  int x0, y0;
  unsigned int width0, height0;
  int x, y;
  unsigned int width, height, border, depth;
  Window root, parent;
  Window *children;
  unsigned int nchildren;
  
  width0 = height0 = x0 = y0 = 0;
  while (XQueryTree(dsp, win, &root, &parent, &children, &nchildren)) {
    XFree((char *)children);
    XGetGeometry(dsp, win, &root, &x, &y, &width, &height, &border, &depth);
    if (!width0) {
      width0 = width;
      height0 = height;
    }
    x0 = x;
    y0 = y;
    win = parent;
    if (win == DefaultRootWindow(dsp))
      break;
  }
  sprintf(buf, "%dx%d+%d+%d", width0, height0, x0, y0);
}

/* return 0: no error */
int write_window_geometry(
#if NeedFunctionProtorypes
			  FILE *fp)
#else
     fp)
     FILE *fp;
#endif
{
  WINGEOMTBL *wp;
  char buf[1024];
  
  fprintf(fp, "%s\n", section_name[2]);
  for (wp = wintbl; wp->symbol != NULL; wp++) {
    gen_geometry_string(buf, *(wp->win));
    fprintf(fp, "%s\t%s\n", wp->symbol, buf);
  }
  return ferror(fp);
}

/* update configuration file
 *
 * return
 *	0	no error
 *	other	error
 */
int update_config_file(
#if NeedFunctionProtorypes
		       void
#endif
		       )
{
  FILE *fp, *ofp;
  char *p;
  Bool f;
  int r, i, section;
  char orgfile[MAXPATH];
  char buf[MAXPATH];
  
  strcpy(orgfile, rcfile);
  fp = fopen(orgfile, "r+");	/* "r+" for writable check */
  if (fp == NULL) {
    p = (char *)getenv("HOME");
    if (p != NULL) {
      sprintf(orgfile, "%s/%s", p, rcfile);
      fp = fopen(orgfile, "r+");
    }
  }
  if (fp == NULL)
    return 1;
  strcpy(buf, orgfile);
  strcat(buf, ".new");
  ofp = fopen(buf, "w");
  if (ofp == NULL)
    return 1;
  r = section = 0;
  while (fgets(buf, sizeof(buf), fp) != NULL) {
    f = True;
    if (buf[0] == '*') {
      i = match_string(section_name, buf);
      if (i < 0)
	i = 0;
      section = i;
    }
    if (section == 2)
      f = False;
    if (f && fputs(buf, ofp) == EOF)
      r = 1;
    if (r)
      break;
  }
  r |= write_window_geometry(ofp);
  fclose(ofp);
  fclose(fp);
  /* rename file, if no error */
  if (!r) {
    strcpy(buf, orgfile);
    strcat(buf, ".new");
    r = rename(buf, orgfile);
  }
  return r;
}

char **split_command(str, filename)
     char *str;
     char *filename;
{
  char *p;
  int i;
  char form[1024];
  static char *args[128];
  static char buf[1024];
  
  strcpy(form, str);
  strcat(form, " %s");		/* for decoder string without filename %s */
  sprintf(buf, form, filename, "");
  p = buf;
  for (i = 0; i < 128-1; i++) {
    p = skip_space(p);
    if (*p == '\0' || *p == '\n')
      break;
    args[i] = p;
    while (*p > ' ')
      p++;
    while (*p == ' '|| *p == '\t' || *p == '\n')
      *p++ = '\0';
  }
  args[i] = NULL;
  return args;
}

int autosavecol()
{
  FILE *fp;
  char *p;
  char name[MAXPATH];
  
  reset_color_pushed(-1);
  p = (char *)getenv("HOME");
  if (p == NULL)
    p = ".";
  strcpy(name, p);
  strcat(name, "/#xpxsave.kcf");
  fp = fopen(name, "w");
  if (fp == NULL)
    return 1;
  wr_kcf(fp);
  return fclose(fp);
}

int autosaveimg()
{
  FILE *fp;
  char *p;
  char name[MAXPATH];
  
  p = (char *)getenv("HOME");
  if (p == NULL)
    p = ".";
  strcpy(name, p);
  strcat(name, "/#xpxsave.cel");
  fp = fopen(name, "w");
  if (fp == NULL)
    return 1;
  wr_cel(fp);
  return fclose(fp);
}

int autosave()
{
  int r;
  
  r = 0;
  if (colchanged)
    r |= autosavecol();
  if (imgchanged)
    r |= autosaveimg();
  return r;
}

int read_any_file(p, name)
     FTYPE *p;
     char *name;
{
  FILE *fp;
  int i, r, fd[2];

  cursor_busy();
  autosave();
  undo_clear();
  message("``%s'' reading...", name);
  if (p->decoder != NULL) {
    pipe(fd);
    if (vfork() == 0) {
      char **av;
      close(1);
      dup(fd[1]);
      close(fd[1]);
      close(fd[0]);
      av = split_command(p->decoder, name);
      execvp(*av, av);
      _exit(1);
    }
    fp = fdopen(fd[0], "r");
    close(fd[1]);
  } else {
    fp = fopen(name, "r");
    if (fp == NULL) {
      message("!open error!\n");
      return 1;
    }
  }
  if (p->mode & F_COL) {
    set_colfilename(name);
    colchanged = missed_color = 0;
    colposx = colposy = 0;
  }
  if (p->mode & F_IMG) {
    set_imgfilename(name);
    imgchanged = 0;
    hotspotx = hotspoty = -1;
    imgposx = imgposy = imgfiledepth = 0;
  }
  r = 1;
  if (p->readroutine != NULL)
    r = p->readroutine(fp);
  fclose(fp);
  if (p->decoder != NULL)
    wait(&i);
  if (r) {
    if (p->mode & F_COL)
      set_colfilename("");
    if (p->mode & F_IMG)
      set_imgfilename("");
    message("!read error!\n");
    return r;
  }
  img_scroll_posreset();
  message("done.\n");
  info_imgsize_set();		/* update info numbers */
  return 0;
}


int write_any_file(p, name)
     FTYPE *p;
     char *name;
{
  FILE *fp;
  int r, i, fd[2];
  
  cursor_busy();
  autosave();
  undo_clear();
  message("``%s'' writing...", name);
  if (p->writeroutine == NULL) {
    message("!\nNot supported format!\nAbort.\n");
    return 1;
  }
  fp = fopen(name, "w");
  if (fp == NULL) {
    message("!open error!\n");
    return 1;
  }
  if (p->encoder != NULL) {
    char **av;
    
    pipe(fd);
    if (vfork() == 0) {
      close(0);
      dup(fd[0]);
      close(1);
      dup(fileno(fp));
      close(fd[1]);
      close(fd[0]);
      av = split_command(p->encoder, "");
      execvp(*av, av);
      _exit(1);
    }
    fp = fdopen(fd[1], "w");
    close(fd[0]);
  }
  r = p->writeroutine(fp, name);
  fclose(fp);
  if (p->encoder != NULL)
    wait(&i);
  if (r) {
    message("!write error!\n");
    return r;
  }
  if (p->mode & F_COL) {
    colchanged = 0;
    set_colfilename(name);
  }
  if (p->mode & F_IMG) {
    imgchanged = 0;
    set_imgfilename(name);
  }
  message("done.\n");
  return 0;
}

int get_filetype(name)
     char *name;
{
  int i, n;
  
  n = get_filetype_max();
  while (--n >= 0) {
    i = strlen(name) - strlen(file_type_tbl[n].suffix);
    if (i >= 0 && strcmp(name+i, file_type_tbl[n].suffix) == 0)
      break;
  }
  return n;
}

int read_data_file(name)
     char *name;
{
  int i;
  
  i = get_filetype(name);
  if (i < 0)
    return 1;
  return read_any_file(file_type_tbl+i, name);
}

int file_open()
{
  int i;
  char buf[MAXPATH];
  
  i = strlen(current_name);
  if (i && current_name[i-1] == '/') {
    strcpy(buf, current_name);
    buf[i-1] = '\0';
    change_directory(buf);
    set_current_name("");
  }
  if (current_name[0] == '\0')
    return 1;
  sprintf(buf, "%s/%s", current_path, current_name);
  return read_data_file(buf);
}

int change_select_slot(
#if NeedFunctionProtorypes
		       char *name)
#else
     name)
     char *name;
#endif
{
  int i;
  
  for (i = 0; i < files_count; i++) {
    if (strcmp(filenamebuf+i*MAXFILENAME, name) == 0)
      return select_slot = i;
  }
  return -1;
}

int file_save()
{
  int i, r;
  char buf[MAXPATH];
  
  i = strlen(current_name);
  if (!i || current_name[i-1] == '/')
    return 1;
  sprintf(buf, "%s/%s", current_path, current_name);
  i = get_filetype(buf);
  if (i < 0)
    return 1;
  r = write_any_file(file_type_tbl+i, buf);
  if (r == 0) {
    rescan_disp_fileslot();
    change_select_slot(current_name);
    rescan_disp_fileslot();
  }
  return r;
}

int file_remove()
{
  int i;
  char buf[MAXPATH];
  
  i = strlen(current_name);
  if (!i || current_name[i-1] == '/')
    return 1;
  sprintf(buf, "%s/%s", current_path, current_name);
  if (unlink(buf) == 0) {
    rescan_disp_fileslot();
    set_select_slot_name();
  }
  return 0;
}

MENU *max_sloty()
{
  int i;
  MENU *p, *rp;
  
  rp = p = fileslot;
  for (i = 0; i < FILESLOTMAX; i++) {
    if (rp->y < p->y)
      rp = p;
    p++;
  }
  return rp;
}

MENU *min_sloty()
{
  int i;
  MENU *p, *rp;
  
  rp = p = fileslot;
  for (i = 0; i < FILESLOTMAX; i++) {
    if (rp->y > p->y)
      rp = p;
    p++;
  }
  return rp;
}

typedef struct {
  int n;
  MENU m;
} SMENU;

int cmp_slot(p1, p2)
     SMENU *p1;
     SMENU *p2;
{
  return p1->m.y - p2->m.y;
}

void sort_slot()
{
  int i;
  SMENU buf[FILESLOTMAX];
  
  for (i = 0; i < FILESLOTMAX; i++) {
    buf[i].n = slotindex[i];
    buf[i].m = *(fileslot+i);
  }
  qsort(buf, FILESLOTMAX, sizeof(*buf), cmp_slot);
  for (i = 0; i < FILESLOTMAX; i++) {
    slotindex[i] = buf[i].n;
    *(fileslot+i) = buf[i].m;
    (fileslot+i)->n = i;
  }
}

void scroll_up(n)
     int n;
{
  int i;
  MENU *p, *mx;
  
  if (scroll_pos + n > scroll_range)
    n = scroll_range - scroll_pos;
  scroll_pos += n;
  for (i = 0; i < FILESLOTMAX; i++)
    (fileslot+i)->y -= n;
  while (p = min_sloty(), p->y + p->h <= 0) {
    mx = max_sloty();
    p->y = mx->y + mx->h;
    slotindex[p-fileslot] += FILESLOTMAX;
    set_slotmode(p-fileslot);
    redraw_window(p->win);
  }
  sort_slot();
  p = fileslot;
  for (i = 0; i < FILESLOTMAX; i++) {
    XMoveWindow(dsp, p->win, p->x, p->y);
    p++;
  }
  resize_slider();
}

void scroll_down(n)
     int n;
{
  int i;
  MENU *p, *mn;
  
  if (scroll_pos - n < 0)
    n = scroll_pos;
  scroll_pos -= n;
  for (i = 0; i < FILESLOTMAX; i++)
    (fileslot+i)->y += n;
  while (p = max_sloty(), p->y >= DIRSLOTH*DIRSLOTMAX) {
    mn = min_sloty();
    p->y = mn->y - p->h;
    slotindex[p-fileslot] -= FILESLOTMAX;
    set_slotmode(p-fileslot);
    redraw_window(p->win);
  }
  sort_slot();
  for (i = FILESLOTMAX-1; i >= 0; --i) {
    p = fileslot+i;
    XMoveWindow(dsp, p->win, p->x, p->y);
  }
  resize_slider();
}

int slotev(p, ev)
     MENU *p;
     XEvent *ev;
{
  int i, oldsel;
  
  switch(ev->type) {
  case ButtonPress:
    oldsel = select_slot;
    select_slot = slotindex[p->n];
    set_current_name(filenamebuf+select_slot*MAXFILENAME);
    for (i = 0; i < FILESLOTMAX; i++) {
      if (slotindex[i] == oldsel) {
	(fileslot+i)->mode &= ~MenuModeMaskOn;
	redraw_window((fileslot+i)->win);
      }
    }
    for (i = 0; i < FILESLOTMAX; i++) {
      if (slotindex[i] == select_slot) {
	(fileslot+i)->mode |= MenuModeMaskOn;
	redraw_window((fileslot+i)->win);
      }
    }
    if (double_clicked)
      file_open();
    return 1;
  }
  return 0;
}

int slotev2(p, ev)
     MENU *p;
     XEvent *ev;
{
  switch(ev->type) {
  case Expose:
    switch(p->n) {
    case DIRSLOT_UP:
      menu_icon_center(p, ICON_up);
      break;
    case DIRSLOT_DOWN:
      menu_icon_center(p, ICON_down);
      break;
    }
    return 1;
  case ButtonPress:
    if (ev->xbutton.button == Button1)
      file_scroll_speed = menu_speed;
    else
      file_scroll_speed = DIRSLOTH*DIRSLOTMAX/2;
  }
  return 0;
}

int fileev(p, ev)
     MENU *p;
     XEvent *ev;
{
  switch(ev->type) {
  case ButtonPress:
    switch(p->n) {
    case FILE_MASK:
      p->mode ^= MenuModeMaskOn;
      rescan_disp_fileslot();
      p->mode ^= MenuModeMaskOn;
      break;
    }
    break;
  case ButtonRelease:
    if (p->mode & MenuModeMaskEnter && p->mode & MenuModeMaskOn) {
      switch(p->n) {
      case FILE_OPEN:
	file_open();
	break;
      case FILE_SAVE:
	file_save();
	break;
      case FILE_REMOVE:
	file_remove();
	break;
      case FILE_DUMMY2:
	break;
      case FILE_OK:
	menu_stat_change(1, 0);
	break;
      }
    }
    break;
  case KeyPress:
    switch(p->n) {
    case FILE_PATH:
      {
	int i;
	KeySym key;
	char buf[16];
	i = XLookupString((XKeyEvent *)ev, buf, sizeof(buf)-1, &key, NULL);
	buf[i] -= '\0';
	switch(key) {
	case XK_KP_Enter:
	case XK_Return:
	  change_directory(p->str);
	  return 1;
	}
      }
      break;
    }
    break;
  case EnterNotify:
    switch(p->n) {
    case FILE_PATH:
      break;
    case FILE_NAME:
      strcpy(p->str, current_name);
      break;
    }
    break;
  case LeaveNotify:
    switch(p->n) {
    case FILE_PATH:
      break;
    case FILE_NAME:
      strcpy(current_name, p->str);
      break;
    }
    break;
  }
  return 0;
}

void file_background()
{
  if (slotwin[DIRSLOT_UP].mode & MenuModeMaskOn)
    scroll_down(file_scroll_speed);
  if (slotwin[DIRSLOT_DOWN].mode & MenuModeMaskOn)
    scroll_up(file_scroll_speed);
}

/* End of file */
