/* $Header: /home/yav/xpx/RCS/grid.c,v 1.13 1995/11/23 16:28:39 yav Exp $
 * xpx gird
 * written by yav (UHD98984@pcvan.or.jp)
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>

#include "headers.h"
#include "xpx.h"
#include "work.h"
#include "griddef.h"
#define PUBLIC_GRID_C
#include "extern.h"

#define GRIDN	3
#define GRIDW	24
#define GRIDH	18
#define MAXGRID	32

char rcsid_grid[] = "$Id: grid.c,v 1.13 1995/11/23 16:28:39 yav Exp $";

int gridev();

#define IMASK (ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask)
static MENU gridmenu[] = {
  {
    GRID_OUT,	MenuModeMaskBorder,
    0, 0, GRIDW, GRIDH,
    0, IMASK, 0,
    gridev, NULL, 0, 0, "<"},
  {
    GRID_NUM,	MenuModeMaskBorder,
    GRIDW+BDW, 0, GRIDW, GRIDH,
    0, IMASK|KeyPressMask, 0,
    gridev, NULL, 0, 8, NULL},
  {
    GRID_IN,	MenuModeMaskBorder,
    (GRIDW+BDW)*2, 0, GRIDW, GRIDH,
    0, IMASK, 0,
    gridev, NULL, 0, 0, ">"},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};

/* return 0: no changed */
int set_grid_size(
#if NeedFunctionPrototypes
		  int n)
#else
     n)
     int n;
#endif
{
  int last_grid_size;
  
  last_grid_size = grid_size;
  if (0 < n && n <= MAXGRID)
    grid_size = n;
  sprintf(gridmenu[GRID_NUM].str, "%d", grid_size);
  gridmenu[GRID_NUM].cursor = strlen(gridmenu[GRID_NUM].str);
  redraw_window(gridmenu[GRID_NUM].win);
  return grid_size - last_grid_size;
}

void create_grid_window(win, x, y)
     Window win;
     int x;
     int y;
{
  topmenuwin_create(gridmenu, x, y);
  set_grid_size(grid_size);
}

void grid_in()
{
  gridmenu[GRID_IN].mode |= MenuModeMaskOn;
  menuwin_expose_default(&gridmenu[GRID_IN]);
  if (set_grid_size(grid_size+1) && grid_mode)
    img_expose(0, 0, imgwinwidth, imgwinheight);
  gridmenu[GRID_IN].mode &= ~MenuModeMaskOn;
  menuwin_expose_default(&gridmenu[GRID_IN]);
}

void grid_out()
{
  gridmenu[GRID_OUT].mode |= MenuModeMaskOn;
  menuwin_expose_default(&gridmenu[GRID_OUT]);
  if (set_grid_size(grid_size-1) && grid_mode)
    img_expose(0, 0, imgwinwidth, imgwinheight);
  gridmenu[GRID_OUT].mode &= ~MenuModeMaskOn;
  menuwin_expose_default(&gridmenu[GRID_OUT]);
}

int gridev(
#if NeedFunctionPrototypes
	   MENU *p, XEvent *ev)
#else
     p, ev)
     MENU *p;
     XEvent *ev;
#endif
{
  int i;
  KeySym key;
  char buf[16];
  
  switch(ev->type) {
  case ButtonPress:
    p->mode ^= MenuModeMaskOn;
    switch(p->n) {
    case GRID_OUT:
      grid_out();
      break;
    case GRID_NUM:
      grid_mode = p->mode & MenuModeMaskOn ? True : False;
      img_expose(0, 0, imgwinwidth, imgwinheight);
      break;
    case GRID_IN:
      grid_in();
      break;
    }
    redraw_window(p->win);
    return 1;
  case KeyPress:
    switch(p->n) {
    case GRID_NUM:
      i = XLookupString((XKeyEvent *)ev, buf, sizeof(buf)-1, &key, NULL);
      buf[i] = '\0';
      switch(key) {
      case XK_KP_Enter:
      case XK_Return:
	i = strtol(p->str, NULL, 0);
	if (set_grid_size(i) && grid_mode)
	  img_expose(0, 0, imgwinwidth, imgwinheight);
	break;
      }
      break;
    }
    break;
  }
  return 0;
}

/* End of file */
