/* $Header: /home/yav/xpx/RCS/hold.c,v 1.4 1996/04/26 17:22:47 yav Exp $
 * xpx image hold space control
 * written by yav (UHD98984@pcvan.or.jp)
 */

#include <X11/Xlib.h>

#include "headers.h"
#include "xpx.h"
#include "work.h"
#define PUBLIC_HOLD_C
#include "extern.h"

char rcsid_hold[] = "$Id: hold.c,v 1.4 1996/04/26 17:22:47 yav Exp $";

AREA hold = {0, 0, 0, 0};
static unsigned char *holdspace = NULL;

/*
 * Edit buffer -> Hold space
 */
int save_holdspace(src)
     AREA *src;			/* source imgdata area */
{
  int i;
  int y;
  
  if (debug_mode)
    fprintf(stderr, "save_holdspace %d %d %d %d\n",
	    src->x, src->y, src->w, src->h);
  
  /* reset hold space */
  if (holdspace != NULL)
    free(holdspace);
  hold.w = hold.h = 0;
  
  /* alloc hold space */
  i = src->w * src->h;
  holdspace = malloc(i);
  if (holdspace == NULL)
    return 1;			/* more core! */
  hold.w = src->w;
  hold.h = src->h;
  
  /* store */
  for (y = 0; y < src->h; y++)
    memcpy(holdspace+hold.w*y, imgdata+(src->y+y)*imgmaxw+src->x, hold.w);
  if (debug_mode)
    fprintf(stderr, "save done.\n");
  return 0;			/* success */
}

/*
 * Edit buffer <- Hold space
 */
int load_holdspace(dst)
     AREA *dst;			/* destimation imgdata area */
				/* update dst.w dst.h */
{
  int x, y;
  int lastnocopypixel;
  unsigned char *srcp, *dstp;
  char *mp;
  
  if (debug_mode)
    fprintf(stderr, "load_holdspace %d %d %d %d\n",
	    dst->x, dst->y, dst->w, dst->h);
  if (holdspace == NULL) {
    message("!Hold space empty.\n");
    return 1;			/* hold space empty */
  }
  if (dst->w > hold.w)
    dst->w = hold.w;
  if (dst->h > hold.h)
    dst->h = hold.h;
  lastnocopypixel = nocopypixel;
  if (!nocopypixel_mode)
    nocopypixel = -1;
  mp = colmask+current_pal*MAXPALSET;
  for (y = 0; y < dst->h; y++) {
    dstp = imgdata + (dst->y+y)*imgmaxw + dst->x;
    srcp = holdspace + y*hold.w;
    for (x = 0; x < dst->w; x++) {
      if (!*(mp+*(dstp+x)) && *(srcp+x) != nocopypixel)
	*(dstp+x) = *(srcp+x);
    }
  }
  update_area(dst->x, dst->y, dst->w, dst->h); /* XImage update */
  nocopypixel = lastnocopypixel;
  if (debug_mode)
    fprintf(stderr, "load done.\n");
  return 0;			/* success */
}

/* End of file */
