/* $Header: /home/yav/xpx/RCS/icon.c,v 1.7 1996/03/26 15:38:43 yav Exp $
 * xpx icon
 * written by yav (UHD98984@pcvan.or.jp)
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "headers.h"
#include "xpx.h"
#include "work.h"
#define PUBLIC_ICON_C
#include "extern.h"


char rcsid_icon[] = "$Id: icon.c,v 1.7 1996/03/26 15:38:43 yav Exp $";

#define BITS static unsigned char
#include "iconbits"

struct {
  short w;
  short h;
  char *bits;
} icondata[] = {
#include "iconsize"
  {0, 0, NULL}
};

#define IPXMAX	32
static Pixmap ipx[IPXMAX];
static Pixmap ipx2[IPXMAX];
static int ipxn;

Pixmap icon_pixmap(n)
     int n;
{
  if (n & 0x80)
    return ipx2[(n&0x7f)-1];
  return ipx[n-1];
}

int icon_width(n)
     int n;
{
  return icondata[(n & 0x7f)-1].w;
}

int icon_height(n)
     int n;
{
  return icondata[(n & 0x7f)-1].h;
}

int create_icon_pixmap()
{
  for (ipxn = 0; ipxn < IPXMAX; ipxn++) {
    if (icondata[ipxn].bits == NULL)
      break;
    ipx[ipxn] =
      XCreatePixmapFromBitmapData(dsp, DefaultRootWindow(dsp),
				  icondata[ipxn].bits, 
				  icondata[ipxn].w, icondata[ipxn].h, 
				  fg, bg, DefaultDepth(dsp, scr));
    if (ipx[ipxn] == None)
      return error("icon pixmap create error!");
    ipx2[ipxn] =
      XCreatePixmapFromBitmapData(dsp, DefaultRootWindow(dsp),
				  icondata[ipxn].bits, 
				  icondata[ipxn].w, icondata[ipxn].h, 
				  bg, fg, DefaultDepth(dsp, scr));
    if (ipx2[ipxn] == None)
      return error("icon pixmap create error!");
  }
  return 0;
}

void free_icon_pixmap()
{
  int i;

  for (i = 0; i < ipxn; i++) {
    XFreePixmap(dsp, ipx[i]);
    XFreePixmap(dsp, ipx2[i]);
  }
}

/* End of file */
