/* $Header: /home/yav/xpx/RCS/inputstr.c,v 1.9 1995/11/25 16:06:57 yav Exp $
 * xpx string input
 * written by yav (UHD98984@pcvan.or.jp)
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>

#include "headers.h"
#include "xpx.h"
#define PIBLIC_INPUTSTR_C
#include "extern.h"

char rcsid_inputstr[] = "$Id: inputstr.c,v 1.9 1995/11/25 16:06:57 yav Exp $";

/*
 * buf:           str:
 *     abcdef         ghi
 *        ^- pos
 *               |
 *               v
 *     abcghidef
 *           ^- pos
 * return:
 *     insert character count
 */
int insert_string(
#if NeedFunctionPrototypes
	      char *buf, int bufsz, int pos, char *str)
#else
     buf, bufsz, pos, str)
     char *buf;
     int bufsz;
     int pos;
     char *str;
#endif
{
  int i;
  int srclen;
  char *p;
  
  srclen = strlen(str);
  /* move tail */
  i = strlen(buf+pos);
  if (pos + i + srclen >= bufsz)
    return 0;
  if (i == 0) {
    strcpy(buf+pos, str);
  } else {
    p = (char*)malloc(i+1);
    if (p == NULL)
      return 0;
    strcpy(p, buf+pos);
    strcpy(buf+pos+srclen, p);
    free(p);
    strncpy(buf+pos, str, srclen);
  }
  return srclen;
}

/* return != 0 cannot to delete
 */
int delete_character(
#if NeedFunctionPrototypes
		 char *buf, int pos)
#else
     buf, pos)
     char *buf;
     int pos;
#endif
{
  int i;
  char *p;
  
  i = strlen(buf) - pos;
  if (i > 0) {
    p = (char*)malloc(i+1);
    if (p != NULL) {
      strcpy(p, buf+pos+1);
      strcpy(buf+pos, p);
      free(p);
      return 0;
    }
  }
  return 1;
}

/* return redraw req. bit0:cursor bit1:string bit2:enter bit3:cancel
 */
int edit_string(
#if NeedFunctionPrototypes
	    XKeyEvent *ev, char *buffer, int bufferlen, int *cursor)
#else
     ev, buffer, bufferlen, cursor)
     XKeyEvent *ev;
     char *buffer;
     int bufferlen;
     int *cursor;
#endif
{
  int i;
  KeySym key;
  char buf[16];
  static struct {KeySym sym; int func;} functbl[] = {
    {XK_Right,		'F'-0x40},
    {XK_KP_Right,	'F'-0x40},
    {XK_Left,		'B'-0x40},
    {XK_KP_Left,	'B'-0x40},
    {XK_BackSpace,	'H'-0x40},
    {XK_Delete,		'D'-0x40},
    {XK_Up,		'P'-0x40},
    {XK_KP_Up,		'P'-0x40},
    {XK_Down,		'N'-0x40},
    {XK_KP_Down,	'N'-0x40},
    {XK_KP_Enter,	0x0d},
    {XK_Return,		0x0d},
    {XK_Escape,		0x1b},
    {0, 0}
  };
  
  i = XLookupString(ev, buf, sizeof(buf)-1, &key, NULL);
  buf[i] = '\0';
  for (i = 0; functbl[i].func; i++) {
    if (functbl[i].sym == key) {
      buf[0] = functbl[i].func;
      break;
    }
  }
  switch(buf[0]) {
  case 'F'-0x40:		/* next char */
    if (*cursor < strlen(buffer)) {
      ++*cursor;
      return 1;
    }
    break;
  case 'B'-0x40:		/* backward char */
    if (*cursor > 0) {
      --*cursor;
      return 1;
    }
    break;
  case 'H'-0x40:		/* backward delete char */
    if (*cursor > 0) {
      --*cursor;
      delete_character(buffer, *cursor);
      return 3;
    }
    break;
  case 'D'-0x40:		/* delete char */
    if (*(buffer+*cursor) != '\0') {
      delete_character(buffer, *cursor);
      return 2;
    }
    break;
  case 'A'-0x40:		/* beginning of line */
    *cursor = 0;
    return 1;
  case 'E'-0x40:		/* end of file */
    *cursor = strlen(buffer);
    return 1;
  case 'P'-0x40:		/* previous line (no-operation) */
    break;
  case 'N'-0x40:		/* next line (no-operation) */
    break;
  case 0x0d:			/* enter */
    return 4|3;
  case 0x1b:			/* escape */
    return 8|3;
  default:
    if (strlen(buf) && buf[0] >= ' ') {
      *cursor += insert_string(buffer, bufferlen, *cursor, buf);
      return 3;
    }
  }
  return 0;
}

/* End of file */
