/* $Header: /home/yav/xpx/RCS/main.c,v 1.62 1996/04/24 23:08:27 yav Exp $
 * xpx main routine
 * written by yav (UHD98984@pcvan.or.jp)
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <X11/keysym.h>

#include "headers.h"
#include "xpx.h"
#include "work.h"
#include "menudef.h"
#include "editdef.h"
#define PUBLIC_MAIN_C
#include "extern.h"

#define COLSETX (PALSETX+32)
#define COLSETY PALSETY

#define INTERNAL_ICONPIXMAP 1

/* #define DEFAULT_FONT "8x13" */
/* #define DEFAULT_BOLD_FONT "8x13bold" */
#define DEFAULT_FONT "-adobe-times-medium-r-normal--14-*"
#define DEFAULT_BOLD_FONT "-adobe-times-bold-r-normal--14-*"


char rcsid_main[] = "$Id: main.c,v 1.62 1996/04/24 23:08:27 yav Exp $";
char windowname[128];
static char *str_display = "";
static char *str_geometry = "";
static char *str_background = "Wheat";
static char *str_foreground = "Black";
static char *str_border = "Black";
static char *str_font = NULL;
static char *str_fontbold = NULL;
static int use_private_color = True;
static int use_private_cmap = False;
static char grid_dash_list[2] = {1,1};
static Pixmap xpxiconpixmap = None;
#ifdef INTERNAL_ICONPIXMAP
#include "icon.xbm"
#endif

#include "cursor0.xbm"
#include "cursor1.xbm"

void usage()
{
  fprintf(stderr, "* %s %s *\n", myname, xpx_version);
  fprintf(stderr, "written by yav (UHD98984@pcvan.or.jp)\n");
  fprintf(stderr, "usage : %s [options] col.kcf rei.cel\n", myname);
  exit(1);
}

char *filename(name)
     char *name;
{
  char *p;
  
  if (name[0] == '\0')
    return "*Noname*";
  p = strrchr(name, '/');
  if (p != NULL)
    name = p+1;
  return name;
}

char *basefilename(name)
     char *name;
{
  char *p;
  
  name = filename(name);
  p = strrchr(name, '.');
  if (p != NULL)
    *p = '\0';
  return name;
}


#define col8to32(x) (((x)<<24)|((x)<<16)|((x)<<8)|(x))
void calcol(col, p)
     XColor *col;
     COL *p;
{
  col->red = col8to32(p->rgb.red);
  col->green = col8to32(p->rgb.green);
  col->blue = col8to32(p->rgb.blue);
  col->flags = DoRed|DoGreen|DoBlue;
}

int get_color_sub(i, p)
     int i;
     COL *p;
{
  XColor col;
  unsigned long plane_masks[1];
  int r;
  
  r = 0;
  calcol(&col, p);
  if (*(coltbl+i) & CM_PRIVATE) {
    col.pixel = *(pixtbl+i);
    XStoreColor(dsp, cmap, &col);
  } else {
    if (use_private_color &&
	XAllocColorCells(dsp, cmap, False,
			 plane_masks, 0, &col.pixel, 1)) {
      XStoreColor(dsp, cmap, &col);
      *(coltbl+i) = CM_ALLOCED | CM_UPDATING | CM_PRIVATE;
      alloced_private_color++;
      alloced_color++;
    } else if (XAllocColor(dsp, cmap, &col)) {
      *(coltbl+i) = CM_ALLOCED | CM_UPDATING;
      alloced_color++;
    } else {
      r = 1;			/* alloc error! */
      col.pixel = bg;
      missed_color++;
    }
    *(pixtbl+i) = col.pixel;
  }
  return r;
}

int get_color(p, n)
     COL *p;
     int n;
{
  int i;
  
  for (i = 0; i < n; i++) {
    if (get_color_sub(i, p))
      message("!color %d %d %d cannot allocated!\n",
	      p->rgb.red, p->rgb.green, p->rgb.blue);
    if (i < MAXCOLSET) {
      XSetForeground(dsp, colgc[i], *(pixtbl+i));
      update_colmenu(i);
    }
    p++;
  }
  return i;
}

/* return number of allocated color */
int get_requested_colors()
{
  int i, r;
  
  r = 0;
  for (i = 0; i < MAXCOLSET*MAXPALSET; i++) {
    if (*(coltbl+i) & CM_REQUEST) {
      if (get_color_sub(i, color_buf+i) == 0)
	r++;
      *(coltbl+i) &= ~CM_REQUEST;
    }
  }
  return r;
}

int request_color(p)
     COL *p;
{
  int i;
  
  for (i = 0; i < MAXCOLSET*MAXPALSET; i++) {
    if (!(*(coltbl+i) & (CM_ALLOCED|CM_REQUEST))) {
      *(coltbl+i) = CM_REQUEST;
      (color_buf+i)->rgb.red = p->rgb.red;
      (color_buf+i)->rgb.green = p->rgb.green;
      (color_buf+i)->rgb.blue = p->rgb.blue;
      return i;
    }
  }
  return -1;
}

void request_color2(i, p)
     int i;
     COL *p;
{
  *(coltbl+i) = CM_REQUEST;
  (color_buf+i)->rgb.red = p->rgb.red;
  (color_buf+i)->rgb.green = p->rgb.green;
  (color_buf+i)->rgb.blue = p->rgb.blue;
}

void init_color()
{
  alloced_color = alloced_private_color = missed_color = 0;
  bzero(coltbl, MAXPALSET*MAXCOLSET);
  bzero(colmask, MAXPALSET*MAXCOLSET);
}

/* free common color cells */
void free_color()
{
  int i;
  
  for (i = 0; i < MAXPALSET*MAXCOLSET; i++) {
    if ((*(coltbl+i) & CM_ALLOCED)&&!(*(coltbl+i) & CM_PRIVATE)) {
      XFreeColors(dsp, cmap, pixtbl+i, 1, 0);
      --alloced_color;
      *(coltbl+i) = 0;
    }
  }
}

/* free common and private color cells */
void free_color_all()
{
  int i;
  
  for (i = 0; i < MAXPALSET*MAXCOLSET; i++) {
    if (*(coltbl+i) & CM_ALLOCED) {
      XFreeColors(dsp, cmap, pixtbl+i, 1, 0);
      --alloced_color;
      if (*(coltbl+i) & CM_PRIVATE)
	--alloced_private_color;
      *(coltbl+i) = 0;
    }
  }
}

void init_color_buf()
{
  int i, j;
  typedef struct {
    unsigned char r;
    unsigned char g;
    unsigned char b;
  } RGBDATA;
  static RGBDATA initdata[16] = {
    {  0,  0,  0},{  0,  0,255},{255,  0,  0},{255,  0,255},
    {  0,255,  0},{  0,255,255},{255,255,  0},{127,127,127},
    { 64, 64, 64},{127,127,255},{255,127,127},{255,127,255},
    {127,255,127},{127,255,255},{255,255,127},{255,255,255}
  }; 
#define GRAY(n) {n*17, n*17, n*17}
  static RGBDATA initdata1[16] = {
    GRAY(15), GRAY(0), GRAY(1), GRAY(2),
    GRAY(3), GRAY(4), GRAY(5), GRAY(6),
    GRAY(7), GRAY(8), GRAY(9), GRAY(10),
    GRAY(11), GRAY(12), GRAY(13), GRAY(14)
    };
  static RGBDATA initdata2[16] = {
    GRAY(0), GRAY(1), GRAY(2), GRAY(3),
    GRAY(4), GRAY(5), GRAY(6), GRAY(7),
    GRAY(8), GRAY(9), GRAY(10), GRAY(11),
    GRAY(12), GRAY(13), GRAY(14), GRAY(15)
    };
  
  for (i = 0; i < MAXPALSET; i++) {
    for (j = 0; j < MAXCOLSET; j++) {
      (color_buf+MAXCOLSET*i+j)->rgb.padding = 0;
      (color_buf+MAXCOLSET*i+j)->rgb.blue = initdata[j].b;
      (color_buf+MAXCOLSET*i+j)->rgb.red = initdata[j].r;
      (color_buf+MAXCOLSET*i+j)->rgb.green = initdata[j].g;
    }
  }
  for (j = 0; j < MAXCOLSET; j++) {
    (color_buf+MAXCOLSET+j)->rgb.padding = 0;
    (color_buf+MAXCOLSET+j)->rgb.blue = initdata1[j].b;
    (color_buf+MAXCOLSET+j)->rgb.red = initdata1[j].r;
    (color_buf+MAXCOLSET+j)->rgb.green = initdata1[j].g;
  }
  for (j = 0; j < MAXCOLSET; j++) {
    (color_buf+MAXCOLSET*2+j)->rgb.padding = 0;
    (color_buf+MAXCOLSET*2+j)->rgb.blue = initdata2[j].b;
    (color_buf+MAXCOLSET*2+j)->rgb.red = initdata2[j].r;
    (color_buf+MAXCOLSET*2+j)->rgb.green = initdata2[j].g;
  }
#undef GRAY
}

int alloc_colorbuf()
{
  color_buf = (COL *)malloc(sizeof(COL)*MAXPALSET*MAXCOLSET);
  pixtbl = (unsigned long *)malloc(sizeof(unsigned long)*MAXPALSET*MAXCOLSET);
  coltbl = (char *)malloc(MAXPALSET*MAXCOLSET);
  colmask = (char *)malloc(MAXPALSET*MAXCOLSET);
  return (color_buf == NULL || pixtbl == NULL ||
	  coltbl == NULL || colmask == NULL);
}

void key_event(ev)
     XEvent *ev;
{
  int i, c;
  char buf[32];
  KeySym key;
  XComposeStatus cs;
  static struct {KeySym sym; int func;} functbl[] = {
    {XK_Left,	'4'},
    {XK_Right,	'6'},
    {XK_Up,	'8'},
    {XK_Down,	'2'},
    {XK_KP_Left,	'4'},
    {XK_KP_Right,	'6'},
    {XK_KP_Up,		'8'},
    {XK_KP_Down,	'2'},
    {0, 0}
  };
  
  i = XLookupString((XKeyEvent *)ev, buf, sizeof(buf)-1, &key, &cs);
  buf[i] = '\0';
  c = buf[0];
  for (i = 0; functbl[i].func; i++) {
    if (functbl[i].sym == key) {
      c = functbl[i].func;
      break;
    }
  }
  switch(c) {
  case 'q':
    menu_stat_change(MENU_QUIT, 2);
    break;
  case 'f':
    menu_stat_change(MENU_FILE, 2);
    break;
  case 'i':
    menu_stat_change(MENU_INFO, 2);
    break;
  case 'e':
    menu_stat_change(MENU_EDIT, 2);
    break;
  case 'L'-0x40:
    redraw_window(imgwin);
    break;
  case '-':
    zoom_out();
    break;
  case '+':
  case '=':
    zoom_in();
    break;
  case '2':
  case 'j':
    img_scroll(0, scroll_speed);
    break;
  case 'J':
    img_scroll(0, 1);
    break;
  case '8':
  case 'k':
    img_scroll(0, -scroll_speed);
    break;
  case 'K':
    img_scroll(0, -1);
    break;
  case '6':
  case 'l':
    img_scroll(scroll_speed, 0);
    break;
  case 'L':
    img_scroll(1, 0);
    break;
  case '4':
  case 'h':
    img_scroll(-scroll_speed, 0);
    break;
  case 'H':
    img_scroll(-1, 0);
    break;
  case '1':
    img_scroll(-scroll_speed, scroll_speed);
    break;
  case '3':
    img_scroll(scroll_speed, scroll_speed);
    break;
  case '7':
    img_scroll(-scroll_speed, -scroll_speed);
    break;
  case '9':
    img_scroll(scroll_speed, -scroll_speed);
    break;
  case 'o':
    edit_mode_change(EDIT_PLOT);
    break;
  case 'p':
    edit_mode_change(EDIT_PAINT);
    break;
  case 'c':
    edit_mode_change(EDIT_COPY);
    break;
  case 'b':
    edit_mode_change(EDIT_FILL);
    break;
  case 'n':
    edit_mode_change(EDIT_LINE);
    break;
  case 'u':
    edit_undo();
    break;
  case 'm':
    color_mask_alt_all();
    break;
  case '!':
    map_message_window();
    break;
  case '?':
    message("imgchanged:%d colchanged:%d\n", imgchanged, colchanged);
    break;
  case 0x03:			/* ^C */
    edit_copy_hold();
    break;
  case 'V'-0x40:		/* ^V */
    edit_paste_hold();
    break;
  }
}

int create_icon()
{
#ifdef INTERNAL_ICONPIXMAP
#if 1
  xpxiconpixmap =
    XCreateBitmapFromData(dsp, DefaultRootWindow(dsp),
			  icon_bits, icon_width, icon_height);
#else
  xpxiconpixmap =
    XCreatePixmapFromBitmapData(dsp, DefaultRootWindow(dsp),
				icon_bits, icon_width, icon_height,
				BlackPixel(dsp, scr), WhitePixel(dsp, scr),
				DefaultDepth(dsp, scr));
#endif
  if (xpxiconpixmap == None) {
    error("icon pixmap create error!");
    return 1;
  }
#endif /* INTERNAL_ICONPIXMAP */
  return create_icon_pixmap();
}

void free_icon()
{
  free_icon_pixmap();
  if (xpxiconpixmap != None)
    XFreePixmap(dsp, xpxiconpixmap);
}

int parse_color(col, name)
     XColor *col;
     char *name;
{
  if (!XParseColor(dsp, cmap, name, col)||
      !XAllocColor(dsp, cmap, col))
    return error("``%s'' color alloc error!", name);
  return 0;
}


void make_cursor()
{
  Pixmap src, mask;
  XColor cfore, cback;
  
  curs_watch = XCreateFontCursor(dsp, XC_watch);
  XParseColor(dsp, cmap, "black", &cfore);
  XParseColor(dsp, cmap, "white", &cback);
  src = XCreateBitmapFromData(dsp, DefaultRootWindow(dsp),
			      cursor0_bits, cursor0_width, cursor0_height);
  mask = XCreateBitmapFromData(dsp, DefaultRootWindow(dsp),
			       cursor1_bits, cursor1_width, cursor1_height);
  curs_cross = XCreatePixmapCursor(dsp, src, mask, &cfore, &cback,
				   cursor0_x_hot, cursor0_y_hot);
}

void initialize()
{
  int i;
  XSizeHints hint;
  XColor col;

  dsp = XOpenDisplay(str_display);
  if (!dsp) {
    error("Cannot open display!");
    exit(1);
  }
  scr = DefaultScreen(dsp);
  cmap = DefaultColormap(dsp, scr);
  bg = WhitePixel(dsp, scr);
  border_color = fg = BlackPixel(dsp, scr);
  if (parse_color(&col, str_background) == 0)
    bg = col.pixel;
  if (parse_color(&col, str_foreground) == 0)
    fg = col.pixel;
  if (parse_color(&col, str_border) == 0)
    border_color = col.pixel;
  create_icon();
  hint.flags = 0;
  i = XGeometry(dsp, scr, str_geometry, "428x368", border_width, 1, 1, 0, 0,
		&(hint.x), &(hint.y), &(hint.width), &(hint.height));
  if (i & (XValue|YValue))
    hint.flags |= PPosition;
  if (i & (WidthValue|HeightValue))
    hint.flags |= PSize;
  win = XCreateSimpleWindow(dsp, DefaultRootWindow(dsp),
			    hint.x, hint.y, hint.width, hint.height,
			    border_width, border_color, bg);
  XSetStandardProperties(dsp, win, windowname, windowname, xpxiconpixmap,
			 oargv, oargc, &hint);
  toplevelwin[toplevelwc++] = win;
  if (use_private_cmap) {
    cmap = XCopyColormapAndFree(dsp, cmap);
    XSetWindowColormap(dsp, win, cmap);
  }
  make_cursor();
  if (str_fontbold == NULL)
    str_fontbold = str_font == NULL ? DEFAULT_BOLD_FONT : str_font;
  if (str_font == NULL)
    str_font = DEFAULT_FONT;
  
  fs0 = XLoadQueryFont(dsp, str_fontbold);
  fs1 = XLoadQueryFont(dsp, str_fontbold);
  
  gc0 = XCreateGC(dsp, win, 0, 0);
  XSetBackground(dsp, gc0, bg);
  XSetForeground(dsp, gc0, fg);
  XSetFont(dsp, gc0, fs0->fid);
  
  gc1 = XCreateGC(dsp, win, 0, 0);
  XSetBackground(dsp, gc1, fg);
  XSetForeground(dsp, gc1, bg);
  XSetFont(dsp, gc1, fs0->fid);
  
  areagc = XCreateGC(dsp, win, 0, 0);
  XSetBackground(dsp, areagc, bg);
  XSetForeground(dsp, areagc, fg);
  
  grid0gc = XCreateGC(dsp, win, 0, 0);
  XSetBackground(dsp, grid0gc, bg);
  XSetForeground(dsp, grid0gc, bg);
  
  gridgc = XCreateGC(dsp, win, 0, 0);
  XSetBackground(dsp, gridgc, bg);
  XSetForeground(dsp, gridgc, bg);
  XSetLineAttributes(dsp, gridgc, 0, LineOnOffDash, CapButt, JoinMiter);
  XSetDashes(dsp, gridgc, 0, grid_dash_list, 2);
  
  hatch_pixmap = XCreatePixmapFromBitmapData(dsp, win,
					     hatch_bits, 8, 8, fg, bg,
					     DefaultDepth(dsp, scr));
  
}

#ifdef __STDC__
typedef void *VOIDPTR;
#else
typedef char *VOIDPTR;
#endif

#define OPT_ABBREV_MASK	0x10
#define OPT_FUNC	1
#define OPT_SET_INT	2
#define OPT_GET_INT	3
#define OPT_GET_STR	4

typedef struct {
  char *name;
  VOIDPTR parm;
  char type;
  char setvalue;		/* for OPT_SET_INT */
} OPTION;

#define OPTTBL(name,type,ptr,val) {name, (VOIDPTR)ptr, type, val}

static OPTION opttbl[] = {
  OPTTBL("-?",		OPT_FUNC,	usage,			0),
  OPTTBL("-h",		OPT_FUNC,	usage,			0),
  OPTTBL("-V",		OPT_FUNC,	usage,			0),
  OPTTBL("-help",	OPT_FUNC,	usage,			0),
  OPTTBL("-debug",	OPT_SET_INT,	&debug_mode,		True),
  OPTTBL("-display",	OPT_GET_STR,	&str_display,		0),
  OPTTBL("-geometry",	OPT_GET_STR,	&str_geometry,		0),
  OPTTBL("-background",	OPT_GET_STR,	&str_background,	0),
  OPTTBL("-bg",		OPT_GET_STR,	&str_background,	0),
  OPTTBL("-foreground",	OPT_GET_STR,	&str_foreground,	0),
  OPTTBL("-fg",		OPT_GET_STR,	&str_foreground,	0),
  OPTTBL("-bordercolor",OPT_GET_STR,	&str_border,		0),
  OPTTBL("-bd",		OPT_GET_STR,	&str_border,		0),
  OPTTBL("-font",	OPT_GET_STR,	&str_font,		0),
  OPTTBL("-fn",		OPT_GET_STR,	&str_font,		0),
  OPTTBL("-fb",		OPT_GET_STR,	&str_fontbold,		0),
  OPTTBL("-borderwidth",OPT_GET_INT,	&border_width,		0),
  OPTTBL("-bw",		OPT_GET_INT,	&border_width,		0),
  OPTTBL("-commoncolor",OPT_SET_INT,	&use_private_color,	False),
  OPTTBL("-cmap",	OPT_SET_INT,	&use_private_cmap,	True),
  OPTTBL("-p",		OPT_SET_INT,	&use_private_cmap,	True),
  OPTTBL("-quickconvert",OPT_SET_INT,	&quick_convert,		True),
  OPTTBL("-slowconvert",OPT_SET_INT,	&quick_convert,		False),
  OPTTBL("-backingstore",OPT_GET_INT,	&backingstoremode,	0),
  OPTTBL("-menu",	OPT_GET_INT,	&menumode,		0),
  OPTTBL("-menuspeed",	OPT_GET_INT,	&menu_speed,		0),
  OPTTBL("-zoom",	OPT_GET_INT,	&zoomfactor,		0),
  OPTTBL("-scrollbar",	OPT_GET_INT,	&scrollbarmode,		0),
  OPTTBL("-maxw",	OPT_GET_INT,	&imgmaxw,		0),
  OPTTBL("-maxh",	OPT_GET_INT,	&imgmaxh,		0),
  OPTTBL("-maxz",	OPT_GET_INT,	&maxzoom,		0),
  OPTTBL("-scrollspeed",OPT_GET_INT,	&scroll_speed,		0),
  OPTTBL("-ix",		OPT_GET_INT,	&imgwx,			0),
  OPTTBL("-iy",		OPT_GET_INT,	&imgwy,			0),
  OPTTBL(NULL,		0,		NULL,			0)
};

int parse_option(ac, av)
     int *ac;
     char ***av;
{
  OPTION *p;
  int i;
  typedef void (*VOIDFUNCPTR)();
  
  for (p = opttbl; p->name != NULL; p++) {
    if (strcmp(**av, p->name) == 0) {
      --*ac;
      ++*av;
      switch(p->type & ~OPT_ABBREV_MASK) {
      case OPT_FUNC:
	((VOIDFUNCPTR)(p->parm))();
	break;
      case OPT_SET_INT:
	*((int *)(p->parm)) = p->setvalue;
	break;
      case OPT_GET_INT:
	if (*ac) {
	  *((int *)(p->parm)) = strtol(**av, NULL, 0);
	  ++*av;
	  --*ac;
	}
	break;
      case OPT_GET_STR:
	if (*ac) {
	  *((char **)(p->parm)) = **av;
	  ++*av;
	  --*ac;
	}
	break;
      }
      return 0;
    } else if (p->type & OPT_ABBREV_MASK && 
	       strncmp(**av, p->name, i = strlen(p->name)) == 0) {
      switch(p->type & ~OPT_ABBREV_MASK) {
      case OPT_GET_INT:
	*((int *)(p->parm)) = strtol(**av+i, NULL, 0);
	break;
      case OPT_GET_STR:
	*((char **)(p->parm)) = **av+i;
	break;
      }
      ++*av;
      --*ac;
      return 0;
    }
  }
  return 1;
}


void main(argc, argv)
     int argc; char **argv;
{
  XEvent ev;
  int i;
  Window double_click_win = 0;
  Time l, double_click_time;
  XEvent ahead;
  Bool ignore_event;
  
  oargc = argc;
  oargv = argv;
  errname = myname = filename(*argv);
  strncpy(windowname, myname, sizeof(windowname));
  strncat(windowname, " @ ", sizeof(windowname));
  i = strlen(windowname);
  gethostname(windowname+i, sizeof(windowname)-i);
  windowname[sizeof(windowname)-1] = '\0';
  if (read_config())
    exit(1);
  argv++;
  argc--;
  while (argc > 0) {
    if (parse_option(&argc, &argv)) {
      if (**argv == '-') {
	error("unknown option ``%s''!", *argv);
	usage();
      }
      break;
    }
  }
  initialize();
  if (alloc_colorbuf())
    exit(1);
  if (imgwx == -1 && imgwy == -1) {
    if (!menumode) {
      imgwx = imgwy = 0;
    } else {
      imgwx = 112;		/* 124 */
      imgwy = 52;		/* 64 */
    }
    if (scrollbarmode & 1) {
      imgwx += IMGSCRLW;
      imgwy += IMGSCRLW;
    }
  }
  create_img_window();
  cursor_busy();
  
  menuev_init();
  create_message_window();
  create_info_window();
  create_scrlbar_window();
  create_menu_window(win, MENUX, MENUY);
  create_colset_window(win, COLSETX, COLSETY);
  create_palset_window(win, PALSETX, PALSETY);
  create_filename_window(win, PALSETX, PALSETY-24);
  create_zoom_window(win, 256, 4);
  create_grid_window(win, 340, 4);
  create_cursor_window(win, 256, 30);
  init_tilemask();
  create_tile_window(win, 8, 364);
  create_edit_window();
  create_file_window();
  if (image_alloc()||undo_init()) {
    error("more core!");
    exit(1);
  }
  init_color_buf();
  init_color();
  init_image();
  image_update_all();
  while (argc--)
    read_data_file(*argv++);
  XSelectInput(dsp, win, ExposureMask|StructureNotifyMask|
	       ButtonPressMask|KeyPressMask);
  XMapRaised(dsp, win);
  while (!sw_quit) {
    if (XEventsQueued(dsp, QueuedAfterReading) == 0) {
      XFlush(dsp);
      cursor_free();
      imgscrl_background();
      file_background();
    }
    XNextEvent(dsp, &ev);
    ignore_event = False;
    switch(ev.type) {
    case NoExpose:
      if (ev.xnoexpose.drawable == imgwin)
	imgwin_noexpose = True;
      break;
    case GraphicsExpose:
      if (ev.xgraphicsexpose.drawable == imgwin) {
	img_expose(ev.xgraphicsexpose.x, ev.xgraphicsexpose.y,
		   ev.xgraphicsexpose.width, ev.xgraphicsexpose.height);
	if (ev.xgraphicsexpose.count == 0)
	  imgwin_noexpose = True;
      }
      break;
    case Expose:
      if (ev.xexpose.window == imgwin)
	img_expose(ev.xexpose.x, ev.xexpose.y,
		   ev.xexpose.width, ev.xexpose.height);
      else
	info_expose(&ev);
      break;
    case MappingNotify:
      XRefreshKeyboardMapping((XMappingEvent *)&ev);
      break;
    case KeyPress:
      if (ev.xkey.window == win)
	key_event(&ev);
      break;
    case ConfigureNotify:
      if (ev.xconfigure.window == win)
	resize_img_window();
      break;
    case ButtonPress:
      if (ev.xbutton.window == double_click_win) {
	l = ev.xbutton.time - double_click_time;
	if (l & 0x80000000)
	  l = ~l + 1;
	double_clicked = l < 500;
      } else {
	double_clicked = False;
      }
      double_click_win = ev.xbutton.window;
      double_click_time = ev.xbutton.time;
      info_press(&ev);
      break;
    case EnterNotify:
      if (XEventsQueued(ev.xcrossing.display, QueuedAfterReading) > 0) {
	XPeekEvent(ev.xcrossing.display, &ahead);
	if (ahead.type == LeaveNotify &&
	    ahead.xcrossing.window == ev.xcrossing.window &&
	    ahead.xcrossing.mode == ev.xcrossing.mode &&
	    ahead.xcrossing.detail == ev.xcrossing.detail) {
	  XNextEvent(ev.xcrossing.display, &ev);
	  ignore_event = True;
	}
      }
    case LeaveNotify:
      double_click_win = 0;
      break;
    }
    if (!ignore_event) {
      edit_event(&ev);
      if (ev.type == MotionNotify &&
	  XEventsQueued(ev.xmotion.display, QueuedAfterReading) > 0) {
	XPeekEvent(ev.xmotion.display, &ahead);
	if (ahead.type == MotionNotify &&
	    ahead.xmotion.window == ev.xmotion.window) {
	  XNextEvent(ev.xmotion.display, &ev);
	}
      }
      menuev_event(&ev);
    }
  }
  autosave();
  update_config_file();
#if 1
  menuev_destroy();
  close_message_window();
  close_edit_window();
  close_info_window();
  close_file_window();
  XDestroyWindow(dsp, imgwin);
  free_color_all();
  free_icon();
  XFree((char *)img);
  XFreeGC(dsp, gc1);
  XFreeGC(dsp, gc0);
  XDestroyWindow(dsp, win);
#endif
  XCloseDisplay(dsp);
  exit(0);
}

/* End of file */
