/* $Header: /home/yav/xpx/RCS/paint.c,v 1.4 1995/11/25 19:19:16 yav Exp $
 * Paint routine for xpx
 * written by yav (UHD98984@pcvan.or.jp)
 *
 */

#include <X11/Xlib.h>
#include "xpx.h"
#include "headers.h"
#include "work.h"
#define PUBLIC_PAINT_C
#include "extern.h"

char rcsid_paint[] = "$Id: paint.c,v 1.4 1995/11/25 19:19:16 yav Exp $";
int painted_pixel;

/*
 *   XXX---
 *     ^   <
 */
int paint_left(x, y)
     int x;
     int y;
{
  unsigned char *p;
  
  p = imgdata+y*imgmaxw+x;
  while (x >= 0) {
    if (*p != painted_pixel)
      break;
    --p;
    --x;
  }
  return x;
}

/*
 *   ---XXX
 *  >   ^
 */
int paint_right(x, y)
     int x;
     int y;
{
  unsigned char *p;

  p = imgdata+y*imgmaxw+x;
  while (x < imgfilew) {
    if (*p != painted_pixel)
      break;
    ++p;
    ++x;
  }
  return x;
}

/*
 *   XXX---
 *  >   ^
 */
int paint_next(x, y)
     int x;
     int y;
{
  unsigned char *p;
  
  p = imgdata+y*imgmaxw+x;
  while (x < imgfilew) {
    if (*p == painted_pixel)
      break;
    p++;
    ++x;
  }
  return x;
}

void paint(x, y)
     int x;
     int y;
{
  int left, right;
  
  left = paint_left(x, y) + 1;
  right = paint_right(x, y) - 1;
  if (left > right)
    return;
  fill_area2(left, y, right+1-left, 1, current_col);
#ifdef XPX_PAINT_VISUAL
  area_update(left, y, right+1-left, 1);
#endif
  ++y;
  if (y < imgfileh) {
    /* paint under line */
    for (x = left; x <= right; x = paint_next(x, y))
      paint(x, y);
  }
  y -= 2;
  if (y >= 0) {
    /* paint upper line */
    for (x = left; x <= right; x = paint_next(x, y))
      paint(x, y);
  }
}

/* End of file */
