/* $Header: /home/yav/xpx/RCS/tile.c,v 1.2 1995/11/26 14:17:56 yav Exp $
 * xpx tile mask
 * written by yav (UHD98984@pcvan.or.jp)
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "headers.h"
#include "xpx.h"
#include "work.h"
#include "cursdef.h"
#define PUBLIC_TILE_C
#include "extern.h"

char rcsid_tile[] = "$Id: tile.c,v 1.2 1995/11/26 14:17:56 yav Exp $";

static int tileno = 0;
static char tileptrn[8][8][8] = {
  {				/* 0 solid */
    {1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1}
  },
  {				/* 1 7/8 */
    {1,1,1,0,1,1,1,0},
    {1,1,1,1,1,1,1,1},
    {1,0,1,1,1,0,1,1},
    {1,1,1,1,1,1,1,1},
    {1,1,1,0,1,1,1,0},
    {1,1,1,1,1,1,1,1},
    {1,0,1,1,1,0,1,1},
    {1,1,1,1,1,1,1,1}
  },
  {				/* 2 3/4 */
    {1,0,1,0,1,0,1,0},
    {1,1,1,1,1,1,1,1},
    {1,0,1,0,1,0,1,0},
    {1,1,1,1,1,1,1,1},
    {1,0,1,0,1,0,1,0},
    {1,1,1,1,1,1,1,1},
    {1,0,1,0,1,0,1,0},
    {1,1,1,1,1,1,1,1}
  },
  {				/* 3 5/8 */
    {1,0,1,0,1,0,1,0},
    {1,1,0,1,1,1,0,1},
    {1,0,1,0,1,0,1,0},
    {0,1,1,1,0,1,1,1},
    {1,0,1,0,1,0,1,0},
    {1,1,0,1,1,1,0,1},
    {1,0,1,0,1,0,1,0},
    {0,1,1,1,0,1,1,1}
  },
  {				/* 4 half */
    {1,0,1,0,1,0,1,0},
    {0,1,0,1,0,1,0,1},
    {1,0,1,0,1,0,1,0},
    {0,1,0,1,0,1,0,1},
    {1,0,1,0,1,0,1,0},
    {0,1,0,1,0,1,0,1},
    {1,0,1,0,1,0,1,0},
    {0,1,0,1,0,1,0,1}
  },
  {				/* 5 3/8 */
    {1,0,1,0,1,0,1,0},
    {0,1,0,0,0,1,0,0},
    {1,0,1,0,1,0,1,0},
    {0,0,0,1,0,0,0,1},
    {1,0,1,0,1,0,1,0},
    {0,1,0,0,0,1,0,0},
    {1,0,1,0,1,0,1,0},
    {0,0,0,1,0,0,0,1}
  },
  {				/* 6 1/4 */
    {1,0,1,0,1,0,1,0},
    {0,0,0,0,0,0,0,0},
    {1,0,1,0,1,0,1,0},
    {0,0,0,0,0,0,0,0},
    {1,0,1,0,1,0,1,0},
    {0,0,0,0,0,0,0,0},
    {1,0,1,0,1,0,1,0},
    {0,0,0,0,0,0,0,0}
  },
  {				/* 7 1/8 */
    {1,0,0,0,1,0,0,0},
    {0,0,0,0,0,0,0,0},
    {0,0,1,0,0,0,1,0},
    {0,0,0,0,0,0,0,0},
    {1,0,0,0,1,0,0,0},
    {0,0,0,0,0,0,0,0},
    {0,0,1,0,0,0,1,0},
    {0,0,0,0,0,0,0,0}
  }
};

int tileev(p, ev)
     MENU *p;
     XEvent *ev;
{
  MENU *p0;
  
  switch (ev->type) {
  case ButtonPress:
    p0 = get_top_menu(p) + tileno;
    p0->mode &= ~MenuModeMaskOn;
    redraw_window(p0->win);
    tileno = p->n;
    set_tilemask(&tileptrn[p->n]);
    p->mode |= MenuModeMaskOn;
    redraw_window(p->win);
    return 1;
  }
  return 0;
}

#define TILEW	48
#define TILEH	18

#define IMASK (ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask)

MENU tilemenu[] = {
  {
    0,	MenuModeMaskBorder|MenuModeMaskOn,
    0, (TILEH+BDW)*0, TILEW, TILEH,
    0, IMASK, 0,
    tileev, NULL, 0, 0, "solid"},
  {
    1,	MenuModeMaskBorder,
    0, (TILEH+BDW)*1, TILEW, TILEH,
    0, IMASK, 0,
    tileev, NULL, 0, 0, "7/8"},
  {
    2,	MenuModeMaskBorder,
    0, (TILEH+BDW)*2, TILEW, TILEH,
    0, IMASK, 0,
    tileev, NULL, 0, 0, "3/4"},
  {
    3,	MenuModeMaskBorder,
    0, (TILEH+BDW)*3, TILEW, TILEH,
    0, IMASK, 0,
    tileev, NULL, 0, 0, "5/8"},
  {
    4,	MenuModeMaskBorder,
    0, (TILEH+BDW)*4, TILEW, TILEH,
    0, IMASK, 0,
    tileev, NULL, 0, 0, "half"},
  {
    5,	MenuModeMaskBorder,
    0, (TILEH+BDW)*5, TILEW, TILEH,
    0, IMASK, 0,
    tileev, NULL, 0, 0, "3/8"},
  {
    6,	MenuModeMaskBorder,
    0, (TILEH+BDW)*6, TILEW, TILEH,
    0, IMASK, 0,
    tileev, NULL, 0, 0, "1/4"},
  {
    7,	MenuModeMaskBorder,
    0, (TILEH+BDW)*7, TILEW, TILEH,
    0, IMASK, 0,
    tileev, NULL, 0, 0, "1/8"},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};

int create_tile_window(win, x, y)
     Window win;
     int x;
     int y;
{
  topmenuwin_create(tilemenu, x, y);
  set_tilemask(&tileptrn[0]);
  return 0;
}

/* End of file */
