# $Header: /home/yav/xpx/RCS/xbmsize.awk,v 1.2 1996/03/26 12:32:17 yav Exp $
# pick up bitmap size section from X11 bitmap files
# written by yav (UHD98984@pcvan.or.jp)
#
# input:
# |#define foo_width 48
# |#define foo_height 48
# |static char foo_bits[] = {
# |   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70,
# |	:
# |   0x00, 0xff, 0xff, 0xff, 0xff, 0x4f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30};
#
# output:
# |{48, 48, foo_bits},
#
# input:
# |#define foo_width 48
# |#define foo_height 48
# |#define foo_x_hot 20
# |#define foo_y_hot 27
# |static unsigned char foo_bits[] = {
# |   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70,
# |	:
# |   0x00, 0xff, 0xff, 0xff, 0xff, 0x4f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30};
#
# output:
# |{48, 48, 20, 27, foo_bits},
#
BEGIN {x = y = -1;}

/\#define .*_width/ {w = $3;}
/\#define .*_height/ {h = $3;}
/\#define .*_x_hot/ {x = $3;}
/\#define .*_y_hot/ {y = $3;}

/static.* char .*_bits\[\]/ {
  printf("{%d, %d, ", w, h);
  if (x >= 0 && y >= 0)
    printf("%d, %d, ", x, y);
  if ($2 == "unsigned")
    name = $4;
  else
    name = $3;
  split(name, a, "[");		# foo_bits[] -> foo_bits
  printf("%s},\n", a[1]);
  w = h = 0;
  x = y = -1;
}
