/* $Header: /home/yav/xpx/RCS/zoom.c,v 1.13 1995/11/23 16:28:39 yav Exp $
 * xpx zoom menu
 * written by yav (UHD98984@pcvan.or.jp)
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>

#include "headers.h"
#include "xpx.h"
#include "work.h"
#include "zoomdef.h"
#define PUBLIC_ZOOM_C
#include "extern.h"

#define ZOOMW	24
#define ZOOMH	18

char rcsid_zoom[] = "$Id: zoom.c,v 1.13 1995/11/23 16:28:39 yav Exp $";

int zmev();
int zmev2(
#if NeedFunctionPrototypes
	  MENU *p, XEvent *ev
#endif
	  );

static MENU zoommenu[] = {
  {
    ZOOM_OUT,	MenuModeMaskBorder,
    0, 0, ZOOMW, ZOOMH,
    0, ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    zmev, NULL, 0, 0, "<"},
  {
    ZOOM_NUM,	MenuModeMaskBorder,
    ZOOMW+BDW, 0, ZOOMW, ZOOMH,
    0,
    ExposureMask|EnterWindowMask|LeaveWindowMask|KeyPressMask,
    0,
    zmev2, NULL, 0, 8, NULL},
  {
    ZOOM_IN,	MenuModeMaskBorder,
    (ZOOMW+BDW)*2, 0, ZOOMW, ZOOMH,
    0, ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    zmev, NULL, 0, 0, ">"},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};

/* return 0: no changed */
int set_zoomfactor(
#if NeedFunctionPrototypes
		   int n)
#else
     n)
     int n;
#endif
{
  int last_zoomfactor;
  
  last_zoomfactor = zoomfactor;
  if (0 < n && n <= maxzoom)
    zoomfactor = n;
  sprintf(zoommenu[ZOOM_NUM].str, "%d", zoomfactor);
  zoommenu[ZOOM_NUM].cursor = strlen(zoommenu[ZOOM_NUM].str);
  redraw_window(zoommenu[ZOOM_NUM].win);
  return zoomfactor - last_zoomfactor;
}

void create_zoom_window(win, x, y)
     Window win;
     int x;
     int y;
{
  topmenuwin_create(zoommenu, x, y);
  set_zoomfactor(zoomfactor);
}

void zoom_change(
#if NeedFunctionPrototypes
		 int n)
#else
     n)
     int n;
#endif
{
  if (set_zoomfactor(n)) {
    img_scroll_posreset();
    image_update_all();
  }
}

void zoom_in()
{
  zoommenu[ZOOM_IN].mode |= MenuModeMaskOn;
  menuwin_expose_default(&zoommenu[ZOOM_IN]);
  zoom_change(zoomfactor+1);
  zoommenu[ZOOM_IN].mode &= ~MenuModeMaskOn;
  redraw_window(zoommenu[ZOOM_IN].win);
}

void zoom_out()
{
  zoommenu[ZOOM_OUT].mode |= MenuModeMaskOn;
  menuwin_expose_default(&zoommenu[ZOOM_OUT]);
  zoom_change(zoomfactor-1);
  zoommenu[ZOOM_OUT].mode &= ~MenuModeMaskOn;
  redraw_window(zoommenu[ZOOM_OUT].win);
}

int zmev(p, ev)
     MENU *p;
     XEvent *ev;
{
  switch(ev->type) {
  case ButtonPress:
    switch(p->n) {
    case ZOOM_OUT:
      if (ev->xbutton.button == 1)
	zoom_out();
      else
	zoom_change(1);
      break;
    case ZOOM_IN:
      if (ev->xbutton.button == 1)
	zoom_in();
      else
	zoom_change(maxzoom);
      break;
    }
    return 1;
  }
  return 0;
}

void gen_zoom_str(
#if NeedFunctionPrototypes
		  MENU *p)
#else
     p)
     MENU *p;
#endif
{
}

int zmev2(
#if NeedFunctionPrototypes
	  MENU *p, XEvent *ev)
#else
     p, ev)
     MENU *p;
     XEvent *ev;
#endif
{
  int i;
  KeySym key;
  char buf[16];
  
  switch(ev->type) {
  case KeyPress:
    i = XLookupString((XKeyEvent *)ev, buf, sizeof(buf)-1, &key, NULL);
    buf[i] = '\0';
    switch(key) {
    case XK_KP_Enter:
    case XK_Return:
      i = strtol(p->str, NULL, 0);
      zoom_change(i);
    }
    break;
  }
  return 0;
}

/* End of file */
